

//------------------------------------------------------------------------------
// Programmed by Christof Ermer
//------------------------------------------------------------------------------

//SYSINFO
#define DATUM		"19.03.2015"
#define FUNKTION	"Fraktal PINGPONG 4094 "
#define HARDWARE	"Atmel ATMega16 V3.3"
#define UHRZEIT		"12:00"
#define AUTOR		"Christof Ermer"

#define IHAVENOBRAIN	"I have no brain."	
#define USEYOURS		"Use your own"

/*  HISTORY 
In Interupts...alle Vars deklarieren mit 
volatile uint32_t Tickscounter..
*/

#include <avr\io.h>
#include <ctype.h>
#include <inttypes.h>
#include <avr\pgmspace.h> // <--#include <progmem.h>






#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <avr\interrupt.h>  // obsolete #include <avr\signal.h>

//ACHTUNG STELLT OBSOLETE Procedure in header wieder her
//#include <compat\deprecated.h>
#include <util\delay.h>	//_delay_loop_1 _delay_loop_2 delay_ms
#include <avr\wdt.h>

#include "main.h"		//with Hardware assigns
#include "4094.h"
//#include "Font.h"
#include "debug.h"
#include "uart.h"
#include "Befehle.h"


//CONSTANT ARRAYs IN .TEXT = ROM ARREA   .DATA IST SRAM !! .BSS SRAM
//const char MCA_DELIMTERSTR[] PROGMEM = { ',',0 };
// GLOBALE VARIABLEN 
//uint8_t gu8ProgMode;



uint8_t gu8Status;
//static char gcaNumStr[NUMMAX + 1]; //+1 for the 0
volatile uint16_t gau16Matrix[ 12 ]; //12 Spalten a 16 Bit wo nur 10 gebraucht werden
volatile uint32_t gu32_Ticks; //  T2 timeCounter, only NN_Counter for Keypressings


//uint16_t ADC_10Bit(uint8_t ucChan);
//void SetColVal( uint16_t u16Val );

//#define TICK_1000MS 977
ISR( TIMER2_OVF_vect ) //TIMER2_COMPA_vect TIMER2_COMPB_vect
{

// UPDATE BILDSCHIRM
//Toggle_Bit(1);
OCR2++;
OCR2 %= 12; // OCR2 ist nur eine Variable
Write_OUT4094( 0xFFF, 12 ); // WERT, ShiftBits
//Lege Daten an	
PORTC &= ~0x0F;
PORTC |=  gau16Matrix[ OCR2 ] & VAL_PORTC_MSK;

PORTD &= ~0xF0;
PORTD  |= gau16Matrix[ OCR2 ] & VAL_PORTD_MSK;

PORTB &= ~0x03;
PORTB |= ((gau16Matrix[ OCR2 ] & VAL_PORTB_MSK) >> 8);
//Schreibe Daten
Write_OUT4094( ~(1U << OCR2), 12); // WERT, ShitBits

gu32_Ticks++;
if( (gu32_Ticks % 100U) == 1)
	{
	gu8Status |= UART_RX_EVENT;	
	}; 	
	
if( (gu32_Ticks % (977U)) == 1 )
	{
	gu8Status |= TICK_EVENT;	
	}; 	
//Toggle_Bit(2);
};
	
	
/*
// ***************************************
void SetColVal( uint16_t u16Val )
// ***************************************
{
PORTC &= ~0x0F;
PORTC |=  u16Val & VAL_PORTC_MSK;

PORTD &= ~0xF0;
PORTD  |= u16Val & VAL_PORTD_MSK;

PORTB &= ~0x03;
PORTB |= ((u16Val & VAL_PORTB_MSK) >> 8);
};
*/


// PRESCALER 3,6864 /  32 = 115200 50-200Khz gewnscht
// REM ADC4-ADC5 = 8 BIT;
// 4+2 Channel. 
//****************************************************************
uint16_t ADC_10Bit(uint8_t ucChan)
//****************************************************************
{
DDRC &= ~(1<<ucChan);   //port A Chanel Bit Input  
PORTC &= ~(1<<ucChan); //Wegen Pullup abschalten
  // Activate ADC with Prescaler 16 --> 16Mhz/128 = 125 khz
ADCSRA = _BV(ADEN) | _BV(ADPS2) | _BV(ADPS1) | _BV(ADPS0);   // 1MHZ / 8
 // Select pin ADC0 using MUX
ADMUX = (ucChan ); //ADC_MUX_MASK = 0b00000111
    
ADCSRA |= _BV(ADSC);  //Start conversion 
while (ADCSRA & _BV(ADSC) ) // wait until converstion completed
	{
	wdt_reset();
	};	   
return ADC;// get converted value
};


//  *************
void CLrMatrix( void)
//  *************
{
register uint8_t u8NN =11;
do
	{
	gau16Matrix[u8NN]=0;
	}while( u8NN--);
};

#define double_TO_NUM_ENABLED
// Braucht 20% Speicher
//#define double_TO_NUM_ENABLED
#ifdef double_TO_NUM_ENABLED
#define double_PRAEDIGITS_MAX	3 // DIgits nach //dtostrf(fVal,NUMMAX, DIGITS_MAX, gcaNumStr);
#define double_DIGITS_MAX		10 // DIgits nach //dtostrf(fVal,NUMMAX, DIGITS_MAX, gcaNumStr);
// **********************************************
void DToA(double fVal)
// *************
{
dtostrf(fVal, double_PRAEDIGITS_MAX, double_DIGITS_MAX, gcaNumStr ); //[-]d.ddd
};
#endif


#define MATRIX_ZEILEN 	12.0
#define MATRIX_SPALTEN	10.0

#define ITERATION_MAX	100
#define X_MIN 			-1.6
#define X_WIDTH			2.1

#define Y_MIN 			-0.9
#define Y_WIDTH			1.8

//GLOABL
double dX_Min = X_MIN;
double dX_Width = X_WIDTH;
double dY_Min = Y_MIN;
double dY_Width = Y_WIDTH;
uint16_t u16IterartionMax = ITERATION_MAX;


//Fraktalberechnung
// ****************************************************************
void Fraktal( double fX_Min, double fX_Width,double fY_Min, double fY_Width )
// ****************************************************************
{
//http://warp.povusers.org/Mandelbrot/
#define ITERATION_ENDE	0x01
#define INSIDE			0x02
uint8_t u8Event = 0;

uint8_t u8XX;
uint8_t u8YY;
uint16_t u16IterNN;

double fRN;
double fIN;
double fReal;
double fImag;
double fBetrag;
double fINC_X; //OFFSET
double fINC_Y; //OFFSET
double fXC;
double fYC; 
//float  _Complex a = 1;

//Feld lschen
CLrMatrix();

fINC_X = fX_Width / MATRIX_ZEILEN; 	//OFFSET
fINC_Y = fY_Width / MATRIX_SPALTEN ; //OFFSET

//ANFANG
fXC = fX_Min;
fYC = fY_Min;
// Zn+^= Z^2 + C
for( u8YY = 0 ; u8YY < MATRIX_SPALTEN ; u8YY++)	
	{
	
	for( u8XX = 0 ; u8XX < MATRIX_ZEILEN ; u8XX++)
		{
		fRN 	= 0;
		fIN 	= 0;
		u8Event |= INSIDE;
		//u8Event &= ~ITERATION_ENDE;	
		
		for( u16IterNN=0; u16IterNN < u16IterartionMax; u16IterNN++)
			{
wdt_reset();   //WATCHDOG			
			fReal	= fRN * fRN;
			fImag	= fIN * fIN;
			fBetrag	= (fReal* fReal) + (fImag * fImag);
			if( fBetrag >= 4.0 )
				{
				if( u16IterNN % 2 )
					{
					gau16Matrix[u8XX] |= (1 << u8YY);
					};
				u8Event &= ~INSIDE;
				break;
				};
			fIN	= (fIN * fRN * 2 ) + fYC;
			fRN = fReal - fImag + fXC;	
			};
		
		if( u8Event & INSIDE)
			{
			//gau16Matrix[u8XX] |= (1 << u8YY); // inside
			};
		fXC += fINC_X;
		};
		
	fXC = fX_Min;  //Weider auf Anfang stellen
	fYC += fINC_Y;
	};
};



// *******************************************************************
// *******************************************************************
int main(void)
// *******************************************************************
// *******************************************************************
{
//uint32_t u32Now;
uint8_t u8TT;

DDRD |= _BV( PD2 ) | _BV( PD1 );
PORTD &= ~_BV( PD2 ); // Potiground auf 0;

CMOS4094_INITDIRREG();
DDRC |= BLOCK1_DDRC;
DDRD |= BLOCK2_DDRD;
DDRB |= BLOCK3_DDRB;


//SFIOR = (1<<PUD); //Pullup Disable

//Pointer and Strings init
wdt_enable(WDTO_2S); //Set 1.9Sec WatchDog ENABLE
wdt_reset();   //WATCHDOG!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


TIMSK &= ~( (1 << TOIE2)  );
TIFR |= (1 << TOV2) ; // zum lschen setzen!
//TIMER STARTS with Presscale Select 
//TCCR2 = (1 << CS22) | (1 << CS20) ;// /128 
//TCCR2 = (1 << CS20) ;	//  /1
//TCCR2 = (1 << CS21) ;	//  /8
TCCR2 = (1 << CS22) ;	//  /64
TIMSK |= (1<< TOIE2);
sei();

uart_init( UART_BAUD_SELECT(UART_BAUD_RATE, F_CPU) );
sei(); 
ResetRxBuff();
		
//Lissajous Figuren****************
/*for(u8TT = 0; u8TT < 120; u8TT++)	
		{	

	u8YY = (5 + 5 * sin( 2 * M_PI *1 * u8TT/119 + M_PI) );//(offset ; Amplitude ; Frequenz ; Berechnungen ; Phase)
	u8XX = (6 + 5 * cos( 2 * M_PI *3 * u8TT/119 + M_PI) );
	gau16Matrix[u8XX] |= (1<< u8YY) ;	

		};	
*/
//gu8Status |= STATUS_TRIGGER_OUTPUT;
gu8Status =0;


while(1)
	{
	wdt_reset();   //WATCHDOG
	//gau16Matrix[0] = 0xFF;

	if( (gu32_Ticks % 100) == 1 )
			{
Toggle_Bit(4);
			wdt_reset();   //WATCHDOG
			
		dX_Min = -1.8 + (random() / (RANDOM_MAX*1.0)) * 2.3;
		dX_Width = (random() / (RANDOM_MAX*1.0)) * 2.3;
		dY_Min = -1 + (random() / (RANDOM_MAX*1.0)) * 2.0;
		dY_Width = dX_Width / 12 *10;
/*
uart_puts_p( PSTR("dX_Min=")  ); uart_puts( dtostrf( dX_Min, double_PRAEDIGITS_MAX, double_DIGITS_MAX, gcaNumStr ) );
uart_puts_p( PSTR("   dX_Width=")  ); uart_puts( dtostrf( dX_Width, double_PRAEDIGITS_MAX, double_DIGITS_MAX, gcaNumStr ) );
uart_putc( 13 ); //CR
uart_puts_p( PSTR("dY_Min=")  ); uart_puts( dtostrf( dY_Min, double_PRAEDIGITS_MAX, double_DIGITS_MAX, gcaNumStr ) );
uart_puts_p( PSTR("   dY_Width=")  ); uart_puts( dtostrf( dY_Width, double_PRAEDIGITS_MAX, double_DIGITS_MAX, gcaNumStr ) );
uart_putc( 13 ); //CR
uart_putc( 13 ); //CR

		
			Fraktal( dX_Min, dX_Width, dY_Min, dY_Width );
			wdt_reset();   //WATCHDOG
			};


/*
for( u8TT = 0 ; u8TT < MATRIX_ZEILEN ; u8TT++)
	{
	gau16Matrix[u8TT] |= (1 << (uint8_t)(round(5.0 + 4.0 * sin ( 2.0 * M_PI * (u8TT/ (MATRIX_ZEILEN*1.0)) ))) );
	};
*/
	//u16ADCValue1 = ADC_10Bit( SERVOPOTI_CHANNEL1 ) ;	
	//u16ADCValue2 = ADC_10Bit( SERVOPOTI_CHANNEL2 ) ;	
	//u8XX =  u16ADCValue1/1024.0 *12;
	//u8YY = (u16ADCValue2/1024.0)*10;
#ifdef TICK_USED
	if( gu8Status & TICK_EVENT )
		{
		gu8Status &= ~TICK_EVENT;
Toggle_Bit(2);
		uart_puts_p( PSTR("Tick=") );
		uart_puts( ultoa( gu32_Ticks, gcaStr, 10 ) );
		uart_putc( 13 ); //CR	
		};
#endif

	if( gu8Status & UART_RX_EVENT )
		{
		gu8Status &= ~UART_RX_EVENT;
Toggle_Bit(2);
		UART_TXRX_Check();
		}; 		
	};

};
// ******************* MAIN END ********************************************

/*
float64 RN; 
float64 IN; 
float64 Real; 
float64 Imag; 
float64 Betrag;
int32 IterNN;
IterNN =  RN = IN =  0; 

while( (Betrag < 4 ) && (IterNN < IterationMax) )
	{
	Real = RN * RN;
	Imag = IN * IN;
	//Betrag = Real + Imag;
	IN = (IN *  RN * 2) + YC;
	RN = Real - Imag + XC;
	Betrag = RN + IN;
	IterNN++;
	};
};
*/

/*
uart_puts_p( PSTR("ITNN=")  ); uart_puts( utoa( u16IterNN, gcaStr, 10 ) );
uart_putc( 13 ); //CR
uart_puts_p( PSTR(" X=")  ); uart_puts( utoa( u8XX, gcaStr, 10 ) );
uart_puts_p( PSTR(" Y=")  ); uart_puts( utoa( u8YY, gcaStr, 10 ) );
uart_putc( 13 ); //CR				
wdt_reset();   //WATCHDOG
uart_puts_p( PSTR("  fBetrag=")  ); uart_puts( dtostrf( fBetrag, double_PRAEDIGITS_MAX, double_DIGITS_MAX, gcaNumStr ) );
uart_puts_p( PSTR("  fIN=")  ); uart_puts( dtostrf( fIN, double_PRAEDIGITS_MAX, double_DIGITS_MAX, gcaNumStr ) );
uart_puts_p( PSTR("  fRN=")  ); uart_puts( dtostrf( fRN, double_PRAEDIGITS_MAX, double_DIGITS_MAX, gcaNumStr ) );
uart_putc( 13 ); //CR				
uart_putc( 13 ); //CR				
wdt_reset();   //WATCHDOG
_delay_ms(20);
wdt_reset();   //WATCHDOG
*/
