

/*
PWM & Mnemonic
OCR1A:
16=~1mS
24 fr ~1,5mS
32=2mS
*/

//------------------------------------------------------------------------------
// Programmed by Christof Ermer
//------------------------------------------------------------------------------

#define SOFTWARE	"Pattern Txt ADC PWM"
#define HARDWARE	"Arduino-UNO ATMega328"
#define DATUM		"03.03.2017 12:00"
#define AUTOR		"* Christof Ermer *"
#define IHAVENOBRAIN	"I have no brain"	
#define USEYOURS		"Use your own"

#include <avr/sfr_defs.h>
#include <avr\io.h>
#include <util\delay.h>
#include <avr/wdt.h>
#include <avr\interrupt.h>
#include <stdlib.h>
#include <math.h>
#include <avr\pgmspace.h> // <--#include <progmem.h>
#include "main.h"
#include "uart.h"
#include "Befehle.h"
#include "debug.h"
#include "MAX543.h"
#include "OutPort74-595.h"

// GLOBALE VARIABLEN 
volatile uint32_t gu32_Ticks;	 //  T2 TimerCounter
volatile uint8_t gu8Status;


PGM_P gppmPattern;
uint16_t gu16Parser;  // *( Parser + nn )
uint16_t gu16PatternSize; // Achtung eine 0 muss im Feld sein

const char MCA_ARDUINO_SM[] PROGMEM = {0x08,0x0C,0x04,0x06,0x02,0x03,0x01,0x09};	//CONST ARRAY


const char MCA_STARTREK[] PROGMEM = {0x81,0x42,0x24,0x18,0x24,0x42,0};

const char MCA_Blink[] PROGMEM = {0xAA,0x55,0};
const char MCA_FLASH_LIGHT[] PROGMEM = {0X00,0xFF}; // GEFAHR -- No strlen
const char MCA_BREIT_LIGHT[] PROGMEM = {0x18,0x3C,0xE7,0xFF,0xE7,0x3C,0x18,0};   //die 0 nicht vergessen bei Strlen_P
const char MCA_KNIGHT_RIDER[] PROGMEM = {0x01,0x02,0x04,0x08,0x10,0x20,0x40,0x80,0};
//So ist es richtig
const char MCA_DISCO[] PROGMEM =
{
0xA5,0x5A,
0xA5,0x5A,
0xA5,0x5A,
0xA5,0x5A,
0xA5,0x5A,
0xA5,0x5A,
0xA5,0x5A,

0x01,0x02,0x04,0x08,0x10,0x20,0x40,0x80,0x40,0x20,0x10,0x08,0x04,0x02,
0x01,0x02,0x04,0x08,0x10,0x20,0x40,0x80,0x40,0x20,0x10,0x08,0x04,0x02,
0x01,0x02,0x04,0x08,0x10,0x20,0x40,0x80,0x40,0x20,0x10,0x08,0x04,0x02,
0x01,0x02,0x04,0x08,0x10,0x20,0x40,0x80,0x40,0x20,0x10,0x08,0x04,0x02,
0x01,0x02,0x04,0x08,0x10,0x20,0x40,0x80,0x40,0x20,0x10,0x08,0x04,0x02,
0x01,0x02,0x04,0x08,0x10,0x20,0x40,0x80,0x40,0x20,0x10,0x08,0x04,0x02,
0x01,0x02,0x04,0x08,0x10,0x20,0x40,0x80,0x40,0x20,0x10,0x08,0x04,0x02,
0x01,0x02,0x04,0x08,0x10,0x20,0x40,0x80,0x40,0x20,0x10,0x08,0x04,0x02,

0x81,0x42,0x24,0x18,0x24,0x42,
0x81,0x42,0x24,0x18,0x24,0x42,
0x81,0x42,0x24,0x18,0x24,0x42,
0x81,0x42,0x24,0x18,0x24,0x42,
0x81,0x42,0x24,0x18,0x24,0x42,
0x81,0x42,0x24,0x18,0x24,0x42,
0x81,0x42,0x24,0x18,0x24,0x42,

0x10,0x20,0x40,0x80,0x40,0x20,0x10,0x08,0x04,0x02,

0x05,0x05,0xAA,0xAA,
0x05,0x05,0xAA,0xAA,
0x05,0x05,0xAA,0xAA,
0  // NULL TERMINIERUNG
};



uint8_t gu8StateMach;

// Interrupt Section
// ********************
ISR( TIMER2_OVF_vect )    //Dieser Vector steht in der iom328p.h
// ********************
{ 	// Interrupt Variablen mssen "volatile" deklariert sein
volatile static uint32_t u32MerkeT;
volatile static uint32_t u32LightShowT;
volatile static uint32_t u32UartT;
//Toggle_Bit(1);
//hochzhlen ? 244*/Sekunde
//if( ( (gu32_Ticks++) - u32MerkeT) > TICK_500MS )
if( ( (gu32_Ticks++) - u32MerkeT) > 244  )
	{
	u32MerkeT = gu32_Ticks;	//neue Zeit merken
	gu8Status |= STATUS_TICK_EVENT;
	};
	
	
if( (gu32_Ticks - u32LightShowT) > 3  )
	{
	u32LightShowT = gu32_Ticks;	//neue Zeit merken
	gu8Status |= STATUS_LIGHTSHOW_FLAG;
	};

if( (gu32_Ticks - u32UartT) > 10  )
	{
	u32UartT = gu32_Ticks;	//neue Zeit merken
	UART_TXRX_Check();  //langsam, aber sehen ob was kommt am UART
	};
};

// !! 244*/ Sekunde	


// *************************************
void Timer0_PWM( uint8_t u8PwmRange)
// *************************************
{  // 8BIT TIMER T0   // #define  _BV(x) (1<<(x))
OCR0A = u8PwmRange;
// CLK_1024  FAST_PWM OC0_MODE
TCCR0A = _BV(WGM00) | _BV(WGM01) | _BV(COM0A1);
TCCR0B =  _BV(CS02) | _BV(CS00); // 1024
//16Mhz / 1024 / 256 = ~ 61 Herz 
DDRD |= _BV(PD6); //OC0A
};


//********************************
uint16_t ADC_10Bit(uint8_t u8Chan)
//********************************
/*
Externe 5V REF--Dreaht von AVCC zu 5V+
// PRESCALER 3,6864 / 32 = 115200 50-200Khz gewnscht
*/
{
DDRC &= ~_BV(u8Chan);  //Portx Channel Bit Input  
PORTC &= ~_BV(u8Chan); //Pullup abschalten
//Activate ADC with Prescaler 16 --> 16Mhz/128 = 125 khz
ADMUX = (1<< REFS0) | u8Chan;    //AVCC und AREF mit C an GND
ADCSRA = _BV(ADEN) | _BV(ADPS2) | _BV(ADPS1) |_BV(ADPS0);  
//ADMUX = u8Chan | (1<<REFS0);
_delay_us(10);
ADCSRA |= _BV(ADSC);  //Start conversion 
while( ADCSRA & _BV(ADSC) ) // wait until converstion completed
	{
	//~150S
	wdt_reset();	//WATCHDOG!
	};	   
return ADC;// get converted value
};


// ********************************
void CheckStateMach(void)
// ********************************
{
switch( gu8StateMach )
	{
	case STATEMACH_NIX: 
		{
		break;
		};
	case STATEMACH_STARTREK:
		{
		gppmPattern = MCA_STARTREK;
		gu16PatternSize = sizeof( MCA_STARTREK ); // Achtung eine 0 muss im Feld sein
		gu8StateMach = STATEMACH_NIX;
		break;
		};
	case STATEMACH_BLINK:
		{
		gppmPattern =  MCA_Blink;
		gu16PatternSize = sizeof( MCA_Blink ); // Achtung eine 0 muss im Feld sein
		gu8StateMach = STATEMACH_NIX;
		break;
		};
	case STATEMACH_FLASHLIGHT:
		{
		gppmPattern = MCA_FLASH_LIGHT;
		gu16PatternSize = 2;		// nur 2 Bytr im Array
		gu8StateMach = STATEMACH_NIX;
		break;
		};
	case STATEMACH_BREIT_LIGHT:
		{
		gppmPattern =  MCA_BREIT_LIGHT;
		gu16PatternSize = sizeof( MCA_BREIT_LIGHT ); // Achtung eine 0 muss im Feld sein
		gu8StateMach = STATEMACH_NIX;
		break;
		};
	case  STATEMACH_SHIFT_LR:
		{
		gppmPattern = MCA_KNIGHT_RIDER;
		gu16PatternSize = sizeof( MCA_KNIGHT_RIDER ); // Achtung eine 0 muss im Feld sein
		gu8StateMach = STATEMACH_NIX;
		break;
		};
	case STATEMACH_DISCO:
		{
		gppmPattern = MCA_DISCO;
		gu16PatternSize = sizeof( MCA_DISCO ); // Achtung eine 0 muss im Feld sein
		gu8StateMach = STATEMACH_NIX;
		break;
		};
	case STATEMACH_5POL_MOTOR:
		{
		gppmPattern =  MCA_ARDUINO_SM;
		gu16PatternSize = sizeof(  MCA_ARDUINO_SM ); // Achtung eine 0 muss im Feld sein
		gu8StateMach = STATEMACH_NIX;
		break;
		};
		
		
		
	}; //switch
};



#define ENABLE_DIR DDRC
#define ENABLE_PORT PORTC
#define ENABLE_BIT (1<<0)
#define ENABLE_INIT() 	(ENABLE_DIR |= ENABLE_BIT);
#define SET_ENABLE()	(ENABLE_PORT |= ENABLE_BIT)
#define CLR_ENABLE()	(ENABLE_PORT &= ~ENABLE_BIT)

// *************
int main(void)
// *************
{

uint8_t u8NN;
uint16_t u16NN;
int16_t u16Value;
//ENABLE_DIR |= ENABLE_BIT;

wdt_reset();   //WATCHDOG!
wdt_enable(5); //500mS Totmannknopf

uart_init( UART_BAUD_SELECT_DOUBLE_SPEED( UART_BAUD_RATE, F_CPU) );
sei(); 
ResetRxBuff();

//TickCounter Starten
TCCR2B = (1 << CS22) | (1 << CS21);	//Vorteiler //256 einschalten
TIMSK2 = (1 << TOIE2);	//Interrrupt aktivieren

/*
// PWM mit Timer0
DDRD |= ( 1<< PORTD6 ); // OCOA Out
TCCR0A = (1<< COM0A1 ) | (1<< WGM00) | (1<< WGM01);   //Fast PWM, OC0A-Low
OCR0A = 30;
TCCR0B = (1<< CS00) | (1<< CS02);  // Vorteiler / 1024
#define ENABLE_SERVO_DDRX 	DDRD
#define ENABLE_SERVO_PORT 	PORTD 
#define ENABLE_SERVO_BIT	(1<< PORTD7) 
ENABLE_SERVO_DDRX |= ENABLE_SERVO_BIT; // OUT fr SERVO ENABLE
ENABLE_SERVO_PORT |= ENABLE_SERVO_BIT;
*/

sei();

uart_puts_p( PSTR( HARDWARE ));uart_putc(13); 
uart_puts_p(  PSTR( SOFTWARE ) );uart_putc(13);
uart_puts_p( PSTR( DATUM )  );uart_putc(13); 
uart_puts_p( PSTR( AUTOR ) );uart_putc(13); 
uart_puts_p( PSTR( IHAVENOBRAIN ) );uart_putc(13); 
uart_puts_p( PSTR( USEYOURS ) );uart_putc(13); 

//gu8Status |= STATUS_TRIGGER_OUTPUT;

//Timer0_PWM( 23 );
//ENABLE_INIT();
//SET_ENABLE();

//gu8StateMach = STATEMACH_STARTREK;
//gu8StateMach = STATEMACH_DISCO;

gu8StateMach = STATEMACH_5POL_MOTOR;
CheckStateMach();

u8NN = 0;
for(;;)  //ENSLESS
	{
	sei();
	wdt_reset();	//WATCHDOG!
	
		
	if( gu8Status & STATUS_LIGHTSHOW_FLAG)  // schnellere Aufruf
		{
		gu8Status &= ~STATUS_LIGHTSHOW_FLAG;
		//Toggle_Bit(1);
		//u16NN++;
		//u16NN %= 256;		
		//OUT_74595(u16NN);		
		OUT_74595( pgm_read_byte_near( (PGM_P)(gppmPattern + ((gu16Parser++) % gu16PatternSize) )) ); 
		//OUT_74595( pgm_read_byte_near( MCA_STARTREK + ( (gu16Parser++) % 6 ) ) );
		};
	
	if( gu8Status & STATUS_TICK_EVENT )
		{
		gu8Status &= ~STATUS_TICK_EVENT;
		
		/*
		u8NN %= 15;
		Timer0_PWM( 16 + u8NN );
		u8NN++;		
		*/
		//OCR0A = 10 + ADC_10Bit(0) / 30;
		//u16NN++;
		//u16NN %= 32;
//		OCR0A = 10 + ADC_10Bit(0) / 30;
		//OCR0A = 15+ 8 + 8 * sin( 2* M_PI * (u16NN/32.0)) ;
		
		//Timer0_PWM( ADC_10Bit(0) / 4 ); // So kann man Servo Steuern
		//Timer0_PWM( ADC_10Bit(0)
	
		
		if( gu8Status & STATUS_TRIGGER_OUTPUT ) //TO/TF
			{
			uart_puts_p( PSTR("VAL=") );
			
//			uart_puts( ultoa( ADC_10Bit(0) , gcaStr, 10 ) );
			uart_puts( ultoa( u16NN , gcaStr, 10 ) );			
			uart_putc( 13 ); //CR
			};
		};
	};
}; // main
