
// Kommando SS, 1..6
// Ss,2<13>

//------------------------------------------------------------------------------
// Programmed by Christof Ermer
//------------------------------------------------------------------------------

#define SOFTWARE	"ADCC-TExt"
#define HARDWARE	"Arduino-UNO ATMega328"
#define DATUM		"04.04.2016 12:00"
#define AUTOR		"* Christof Ermer *"
#define IHAVENOBRAIN	"I have no brain"	
#define USEYOURS		"Use your own"

#include <avr/sfr_defs.h>
#include <avr\io.h>
#include <util\delay.h>
#include <avr/wdt.h>
#include <avr\interrupt.h>
#include <stdlib.h> //itoa ultoa
#include <avr\pgmspace.h> // <--#include <progmem.h>
#include <math.h>
#include "main.h"
#include "uart.h"
#include "Befehle.h"
#include "debug.h"
#include "ServiceFunc.h"
#include "max7219.h"

// GLOBALE VARIABLEN 

//char Bloedsinn[300+1];

volatile uint32_t gu32_Ticks;	 //  T2 TimerCounter
volatile uint8_t gu8Status;

PGM_P gppmgPattern;
uint16_t gu16Parser;  // *( Prser + nn )
uint16_t gu16PatternSize; // Achtung eine 0 muss im Feld sein

uint8_t gu8SM_Status;

#ifdef STATE_MACHINE_USED
volatile uint8_t gu8StateMach;
#endif


PGM_P gppmgPattern;
uint16_t gu16Parser;  // *( Parser + nn )
uint16_t gu16PatternSize; // Achtung eine 0 muss im Feld sein


const char MCA_STARTREK[] PROGMEM = {0x81,0x42,0x24,0x18,0x24,0x42,0};
const char MCA_Blink[] PROGMEM = {0xAA,0x55,0};
const char MCA_FLASH_LIGHT[] PROGMEM = {0X00,0xFF,0}; // GEFAHR -- No strlen
const char MCA_BREIT_LIGHT[] PROGMEM = {0x18,0x3C,0xE7,0xFF,0xE7,0x3C,0x18,0};   //die 0 nicht vergessen bei Strlen_P
const char MCA_KNIGHT_RIDER[] PROGMEM = {0x01,0x02,0x04,0x08,0x10,0x20,0x40,0x80,0x40,0x20,0x10,0x08,0x04,0x02,0};

const char MCA_ARDUINO_SM[] PROGMEM = {0x08,0x0C,0x04,0x06,0x02,0x03,0x01,0x09};	//CONST ARRAY

//Experiment kompilere folgende Zeile MIT UND OHNE PROGMEM

//So ist es falsch , weil es RAM verbraucht  !! Jedes einezlne kostbare Byte
//const char MCA_DISCO[] =    // VORSICHT BRAUCHT RAM

//So ist es richtig
const char MCA_DISCO[] PROGMEM =
{
0xA5,0x5A,
0xA5,0x5A,
0xA5,0x5A,
0xA5,0x5A,
0xA5,0x5A,
0xA5,0x5A,
0xA5,0x5A,

0x01,0x02,0x04,0x08,0x10,0x20,0x40,0x80,0x40,0x20,0x10,0x08,0x04,0x02,
0x01,0x02,0x04,0x08,0x10,0x20,0x40,0x80,0x40,0x20,0x10,0x08,0x04,0x02,

0x81,0x42,0x24,0x18,0x24,0x42,
0x81,0x42,0x24,0x18,0x24,0x42,
0x81,0x42,0x24,0x18,0x24,0x42,
0x81,0x42,0x24,0x18,0x24,0x42,
0x81,0x42,0x24,0x18,0x24,0x42,
0x81,0x42,0x24,0x18,0x24,0x42,
0x81,0x42,0x24,0x18,0x24,0x42,
0x81,0x42,0x24,0x18,0x24,0x42,
0x81,0x42,0x24,0x18,0x24,0x42,
0x81,0x42,0x24,0x18,0x24,0x42,
0x81,0x42,0x24,0x18,0x24,0x42,

0x10,0x20,0x40,0x80,0x40,0x20,0x10,0x08,0x04,0x02,

0x05,0x05,0xAA,0xAA,
0x05,0x05,0xAA,0xAA,
0x05,0x05,0xAA,0xAA,
0 //Terminisierungsstring
};


// Interrupt Section
// ********************
ISR( TIMER2_OVF_vect )    //Dieser Vector steht in der iom328p.h
// ********************
{ 	// Interrupt Variablen mssen "volatile" deklariert sein
volatile static uint32_t u32Merke_T;
volatile static uint32_t u32PWM_T;
//hochzhlen ? 244*/Sekunde
gu32_Ticks++;

if( ( (gu32_Ticks) - u32Merke_T) > 1 )
	{
	u32Merke_T = gu32_Ticks;	//neue Zeit merken
	gu8Status |= STATUS_TICK_EVENT;
	};
	
if( ( (gu32_Ticks) - u32PWM_T) > (TICK_1000MS / 7) )
	{
	u32PWM_T = gu32_Ticks;	//neue Zeit merken
	gu8Status |= STATUS_LIGHTSHOW_FLAG;
	};	
// !! 244*/ Sekunde	
sei();
UART_TXRX_Check();  //langsam, aber sehen ob was kommt am UART
};


/*

// ****************************
void Show_Byte(uint8_t u8Val )
// ****************************
{
//Bits an richtige Positionen schieben, wenn ntig!!
#define PORTB_LIGHT_MASKE 0x3F // 0b00111111
#define PORTD_LIGHT_MASKE 0xC0 // 0b11000000
DDRB |= PORTB_LIGHT_MASKE;
DDRD |= PORTD_LIGHT_MASKE;

PORTB &= ~PORTB_LIGHT_MASKE;
PORTB |= u8Val & PORTB_LIGHT_MASKE;
//( (u8Val &PORTD_LIGHT_MASKE) >> 2)
PORTD &= ~PORTD_LIGHT_MASKE;
PORTD |= u8Val & PORTD_LIGHT_MASKE;
};
*/


#ifdef STATE_MACHINE_USED
// ********************************
void CheckStateMach(void)
// ********************************
{
switch( gu8StateMach )
	{
	case STATEMACH_NIX: 
		{
		break;
		};
	case STATEMACH_STARTREK:
		{
		gppmgPattern = MCA_STARTREK;
		gu16PatternSize = sizeof( MCA_STARTREK ); // Achtung eine 0 muss im Feld sein
		gu8StateMach = STATEMACH_NIX;
		break;
		};
	case STATEMACH_BLINK:
		{
		gppmgPattern =  MCA_Blink;
		gu16PatternSize = sizeof( MCA_Blink ); // Achtung eine 0 muss im Feld sein
		gu8StateMach = STATEMACH_NIX;
		break;
		};
	case STATEMACH_FLASHLIGHT:
		{
		gppmgPattern = MCA_FLASH_LIGHT;
		gu16PatternSize = 2;		// nur 2 Bytr im Array
		gu8StateMach = STATEMACH_NIX;
		break;
		};
	case STATEMACH_BREIT_LIGHT:
		{
		gppmgPattern =  MCA_BREIT_LIGHT;
		gu16PatternSize = sizeof( MCA_BREIT_LIGHT ); // Achtung eine 0 muss im Feld sein
		gu8StateMach = STATEMACH_NIX;
		break;
		};
	case  STATEMACH_SHIFT_LR:
		{
		gppmgPattern = MCA_KNIGHT_RIDER;
		gu16PatternSize = sizeof( MCA_KNIGHT_RIDER ); // Achtung eine 0 muss im Feld sein
		gu8StateMach = STATEMACH_NIX;
		break;
		};
	case STATEMACH_DISCO:
		{
		gppmgPattern = MCA_DISCO;
		gu16PatternSize = strlen_P( MCA_DISCO ); // Achtung eine 0 muss im Feld sein
		gu8StateMach = STATEMACH_NIX;
		break;
		};
	}; //switch
};
#endif

// *************
void PotiTon(uint16_t u16Ton)
// *************
{
DDRB |= (1<<1);	//OC1A ausgang OCxx
TCCR1A = (1<<COM1A0);	// Toggle OC1A
TCCR1B = (1<<WGM12) | (1<< CS10); //1024	
OCR1A = u16Ton * 64;
};


#define SM_DDRX			DDRC
#define SM_PORTX		PORTC
#define SM_PORT_MASK	0x0F
#define SM_PORT_INIT()  (SM_DDRX |= SM_PORT_MASK)

// *************
int main(void)
// *************
{
uint8_t u8NN = 0;
uint8_t u8Line;

MAX7219_Init();
MAX7219_Clear();


wdt_reset();   //WATCHDOG!
wdt_enable(5); //500mS Totmannknopf

uart_init( UART_BAUD_SELECT_DOUBLE_SPEED(UART_BAUD_RATE, F_CPU) );
sei(); 
ResetRxBuff();

//TickCounter Starten
TCNT2=0;
TIMSK2 = (1 << TOIE2);	//Interrrupt aktivieren
sei(); //cli();
TCCR2B = (1 << CS21) | (1 << CS20);	//32 //Vorteiler 32 einschalten


uart_puts_p( PSTR( HARDWARE ));uart_putc(13); 
uart_puts_p(  PSTR( SOFTWARE ) );uart_putc(13);
uart_puts_p( PSTR( DATUM )  );uart_putc(13); 
uart_puts_p( PSTR( AUTOR ) );uart_putc(13); 
uart_puts_p( PSTR( IHAVENOBRAIN ) );uart_putc(13); 
uart_puts_p( PSTR( USEYOURS ) );uart_putc(13); 

gu8Status |= STATUS_TICK_MSG_FLAG;

//Timer0_PWM_Start( PWM_SERVO_MITTE );

//
//gu8StateMach = STATEMACH_STARTREK; // siehe "serviceFUnc.c"
gu8StateMach = STATEMACH_DISCO; // siehe "serviceFUnc.c"
CheckStateMach();


SM_PORT_INIT();
gu8SM_Status |= MOTOR_DIRECTION;
gu8SM_Status |= MOTOR_ON;

for(;;) 
	{
	sei();
	wdt_reset();	//WATCHDOG!

	if( gu8Status & STATUS_LIGHTSHOW_FLAG)  // schnellere Aufruf
		{
		gu8Status &= ~STATUS_LIGHTSHOW_FLAG;
		/// Sinus_Servo( u8NN % (uint8_t)XRES );  u8NN++;
		
		u8Line = pgm_read_byte_near( (PGM_P)(gppmgPattern + ((gu16Parser++) % gu16PatternSize) ) );
		MAX7219_Clear();
		MAX7219_Write(1, u8Line);
		//Show_Byte(  )) ); 
		//=pgm_read_byte_near( MCA_STARTREK + ( gu16Parser % 6 ) );
		};

	
	if( gu8Status & STATUS_TICK_EVENT )
		{
		gu8Status &= ~STATUS_TICK_EVENT;
		
		if(gu8SM_Status & MOTOR_ON)
			{
			if( (gu8SM_Status & MOTOR_DIRECTION)  )
				{
				SM_PORTX = pgm_read_byte_near( MCA_ARDUINO_SM + u8NN++ );
				}
			else
				{
				SM_PORTX = pgm_read_byte_near( MCA_ARDUINO_SM + u8NN-- );
				};
			u8NN %= 8;
			};
	
		//PORTB ^= LED1_BLINK;	// ab jetzt langsame ~1Hz Action				
		if( gu8Status & STATUS_TICK_MSG_FLAG ) //TO/TF
			{	
			

//			uart_puts( ultoa( ADC_10Bit(0), gcaStr, 10 ) );
//			PotiTon( ADC_10Bit(0) );
//			uart_putc( 13 );
			
			//uart_putc( 13 ); //CR
			//uart_puts_p( PSTR("== Hier bin ich Aktiv !! ==") );
			//uart_putc( 13 ); //CR
			//
			//uart_puts_p( PSTR("PWM=") );
			//uart_puts( ultoa( OCR0A, gcaStr, 10 ) );
			//uart_putc( 13 ); //CR
			};
			
		};
	CheckStateMach();
//Toggle_Bit(1);
	};
}; // main
