

#include <avr/sfr_defs.h>
#include <avr\io.h>
#include <util\delay.h>
#include <avr/wdt.h>
#include <avr\interrupt.h>
#include <stdlib.h> //itoa ultoa
#include <avr\pgmspace.h> // <--#include <progmem.h>

const char MCA_ARDUINO_SM[] PROGMEM = {0x08,0x0C,0x04,0x06,0x02,0x03,0x01,0x09};	//CONST ARRAY


// ***** ***********************************************************
ISR( TIMER1_COMPA_vect )// signal handler	/#define SIG_OUTPUT_COMPARE1A	_VECTOR(6)
// ***** ***********************************************************
{
volatile static uint8_t u8NN = 0;

if( gu8SM_Status & MOTOR_DIRECTION )
	{
	SM_PORTX = pgm_read_byte_near( MCA_ARDUINO_SM + u8NN++ );
	}
else
	{
	SM_PORTX = pgm_read_byte_near( MCA_ARDUINO_SM + u8NN-- );
	};
u8NN %= 8;
};

// *********************************
void StartTimer_1(uint16_t u16Frq)
// *********************************
{
TCCR1B = 0;
TCNT1 = 0;
gu8SM_Status &= ~MOTOR_ON;
if( u16Frq )
	{
	gu8Status |= MOTOR_ON;
	OCR1A = round( (F_CPU / 1024.0 ) / u16Frq );
	TIMSK1 = _BV(OCIE1A); //Interrupt
	TCCR1B = _BV( WGM12) | _BV( CS12) | _BV(CS10); //CTC + /1024
	gu8SM_Status |= MOTOR_ON;
	sei();
	}
else
	{
	TCCR1B = 0;
	TCNT1 = 0;
	gu8SM_Status &= ~MOTOR_ON;
	};
};

