
// Kommando SS, 1..6
// Ss,2<13>

//------------------------------------------------------------------------------
// Programmed by Christof Ermer
//------------------------------------------------------------------------------

#define SOFTWARE	"SEPTM-4Pol"
#define HARDWARE	"Arduino-UNO ATMega328"
#define DATUM		"05.04.2016 12:00"
#define AUTOR		"* Christof Ermer *"
#define IHAVENOBRAIN	"I have no brain"	
#define USEYOURS		"Use your own"

#include <avr/sfr_defs.h>
#include <avr\io.h>
#include <util\delay.h>
#include <avr/wdt.h>
#include <avr\interrupt.h>
#include <stdlib.h> //itoa ultoa
#include <avr\pgmspace.h> // <--#include <progmem.h>
#include <math.h>
#include "main.h"
#include "uart.h"
#include "Befehle.h"
#include "debug.h"
#include "ServiceFunc.h"
//#include "max7219.h"

// GLOBALE VARIABLEN 

//char Bloedsinn[300+1];

volatile uint32_t gu32_Ticks;	 //  T2 TimerCounter
volatile uint8_t gu8Status;

PGM_P gppmgPattern;
uint16_t gu16Parser;  // *( Prser + nn )
uint16_t gu16PatternSize; // Achtung eine 0 muss im Feld sein

uint8_t gu8SM_Status;

#ifdef STATE_MACHINE_USED
volatile uint8_t gu8StateMach;
#endif


PGM_P gppmgPattern;
uint16_t gu16Parser;  // *( Parser + nn )
uint16_t gu16PatternSize; // Achtung eine 0 muss im Feld sein

const char MCA_ARDUINO_SM[] PROGMEM = {0x08,0x0C,0x04,0x06,0x02,0x03,0x01,0x09};	//CONST ARRAY
const char MCA_FULLSTEP[] PROGMEM = {0x3A, 0x39,0x35,36};
const char MCA_HALFSTEP[] PROGMEM = {0x3A,0x28,0x39,0x11,0x35,0x24,0x36,0x12};

//Experiment kompilere folgende Zeile MIT UND OHNE PROGMEM

//So ist es falsch , weil es RAM verbraucht  !! Jedes einezlne kostbare Byte
//const char MCA_DISCO[] =    // VORSICHT BRAUCHT RAM


// Interrupt Section
// ********************
ISR( TIMER2_OVF_vect )    //Dieser Vector steht in der iom328p.h
// ********************
{ 	// Interrupt Variablen mssen "volatile" deklariert sein
volatile static uint32_t u32Merke_T;
volatile static uint32_t u32PWM_T;
//hochzhlen ? 244*/Sekunde
gu32_Ticks++;

if( ( (gu32_Ticks) - u32Merke_T) > 1 )
	{
	u32Merke_T = gu32_Ticks;	//neue Zeit merken
	gu8Status |= STATUS_TICK_EVENT;
	};
	
if( ( (gu32_Ticks) - u32PWM_T) > (TICK_1000MS / 7) )
	{
	u32PWM_T = gu32_Ticks;	//neue Zeit merken
	gu8Status |= STATUS_LIGHTSHOW_FLAG;
	};	
// !! 244*/ Sekunde	
sei();
UART_TXRX_Check();  //langsam, aber sehen ob was kommt am UART
};



// ***** ***********************************************************
ISR( TIMER1_COMPA_vect )// signal handler	/#define SIG_OUTPUT_COMPARE1A	_VECTOR(6)
// ***** ***********************************************************
{
if( gu8SM_Status & MOTOR_DIRECTION )
	{
	SM_PORTX = pgm_read_byte_near( gppmgPattern + gu16Parser++ );
	}
else
	{
	SM_PORTX = pgm_read_byte_near( gppmgPattern + gu16Parser-- );
	};
gu16Parser %= gu16PatternSize;
};

// *********************************
void StartTimer_1(uint16_t u16Frq)
// *********************************
{
TCCR1B = 0;
TCNT1 = 0;
gu8SM_Status &= ~MOTOR_ON;
if( u16Frq )
	{
	gu8Status |= MOTOR_ON;
	OCR1A = round( (F_CPU / 1024.0 ) / u16Frq );
	TIMSK1 = _BV(OCIE1A); //Interrupt
	TCCR1B = _BV( WGM12) | _BV( CS12) | _BV(CS10); //CTC + /1024
	gu8SM_Status |= MOTOR_ON;
	sei();
	}
else
	{
	TCCR1B = 0;
	TCNT1 = 0;
	gu8SM_Status &= ~MOTOR_ON;
	};
};

#ifdef STATE_MACHINE_USED
// ********************************
void CheckStateMach(void)
// ********************************
{
switch( gu8StateMach )
	{
	case STATEMACH_NIX: 
		{
		break;
		};
		
	case STATEMACH_FULLSTEP: 
		{
		gppmgPattern =  MCA_FULLSTEP ;
		gu16Parser = 0;
		gu16PatternSize = 4;
		gu8StateMach = STATEMACH_NIX;
		break;
		};
	case STATEMACH_HALFSTEP: 
		{
		gppmgPattern =  MCA_HALFSTEP;
		gu16Parser = 0;
		gu16PatternSize = 8;
		gu8StateMach = STATEMACH_NIX;
		break;
		};
	case STATEMACH_5POL_MINISTEP: 
		{
		gppmgPattern =  MCA_ARDUINO_SM;
		gu16PatternSize = 8;
		gu16Parser = 0;
		gu8StateMach = STATEMACH_NIX;
		break;
		};

	}; //switch
};
#endif

// *************
void PotiTon(uint16_t u16Ton)
// *************
{
DDRB |= (1<<1);	//OC1A ausgang OCxx
TCCR1A = (1<<COM1A0);	// Toggle OC1A
TCCR1B = (1<<WGM12) | (1<< CS10); //1024	
OCR1A = u16Ton * 64;
};




// *************
int main(void)
// *************
{
uint8_t u8NN = 0;
uint8_t u8Line;


wdt_reset();   //WATCHDOG!
wdt_enable(5); //500mS Totmannknopf

uart_init( UART_BAUD_SELECT_DOUBLE_SPEED(UART_BAUD_RATE, F_CPU) );
sei(); 
ResetRxBuff();

//TickCounter Starten
TCNT2=0;
TIMSK2 = (1 << TOIE2);	//Interrrupt aktivieren
sei(); //cli();
TCCR2B = (1 << CS21) | (1 << CS20);	//32 //Vorteiler 32 einschalten


uart_puts_p( PSTR( HARDWARE ));uart_putc(13); 
uart_puts_p(  PSTR( SOFTWARE ) );uart_putc(13);
uart_puts_p( PSTR( DATUM )  );uart_putc(13); 
uart_puts_p( PSTR( AUTOR ) );uart_putc(13); 
uart_puts_p( PSTR( IHAVENOBRAIN ) );uart_putc(13); 
uart_puts_p( PSTR( USEYOURS ) );uart_putc(13); 


SM_PORT_INIT();

gu8SM_Status |= MOTOR_DIRECTION;
gu8Status |= STATUS_TICK_MSG_FLAG;
gu8StateMach = STATEMACH_FULLSTEP;
CheckStateMach();
StartTimer_1(100);
for(;;) 
	{
	sei();
	wdt_reset();	//WATCHDOG!

	
	if( gu8Status & STATUS_TICK_EVENT )
		{
		gu8Status &= ~STATUS_TICK_EVENT;
		
		//PORTB ^= LED1_BLINK;	// ab jetzt langsame ~1Hz Action				
		if( gu8Status & STATUS_TICK_MSG_FLAG ) //TO/TF
			{			
//			uart_puts( ultoa( ADC_10Bit(0), gcaStr, 10 ) );
//			PotiTon( ADC_10Bit(0) );
//			uart_putc( 13 );

			//uart_puts_p( PSTR("Speed=") );
			//uart_puts( ultoa( OCR1A, gcaStr, 10 ) );
			//uart_putc( 13 ); //CR
			};
			
		};
	CheckStateMach();
//Toggle_Bit(1);
	};
}; // main
