

#ifndef MAIN_HEADER  //Prevents multiple includes
	#define MAIN_HEADER

#define UART_USE_ENABLED
#define STATE_MACHINE_USED


//#define UART_BAUD_RATE	9600	/* 9600 baud */
//#define UART_BAUD_RATE	2400
//#define UART_BAUD_RATE	19200U
//#define UART_#_RATE		38400U
#define UART_BAUD_RATE	115200UL	//UART_BAUD_SELECT_DOUBLE_SPEED

// 16000000 / 256 = ~244
#define TICK_10SEKUNDEN 2441U
#define TICK_2000MS 488U
#define TICK_1500MS 366U
#define TICK_1000MS 244U
#define TICK_500MS 122U
#define TICK_200MS 49U
#define TICK_250MS 61U
#define TICK_150MS 36U
#define TICK_100MS 24U
#define TICK_50MS 12U
#define TICK_25MS 6U
#define TICK_10MS 2U

//RUNDUNG
//1 MHZ / 256/ 2

// ***** MEINE DEFINES ******

#define LED1_BLINK	(1<<PB5)	//LED an BIT 5
#define STATUS_TICK_EVENT		0x01
#define STATUS_PWM_EVENT		0x02
#define STATUS_TICK_MSG_FLAG	0x04
#define STATUS_LIGHTSHOW_FLAG	0x08
//gu8Status   gu8Status = STATUS_LIGHTSHOW_FLAG;

// STATEMACHINE
#define STATEMACH_NIX			0
#define STATEMACH_FULLSTEP		1
#define STATEMACH_HALFSTEP		2
#define STATEMACH_5POL_MINISTEP	3


extern volatile uint32_t gu32_Ticks;
extern PGM_P gppmgPattern;
extern uint16_t gu16Parser;  // *( Prser + nn )
extern uint16_t gu16PatternSize; // Achtung eine 0 muss im Feld sein

#ifdef STATE_MACHINE_USED
extern volatile uint8_t gu8StateMach;
#endif

#define SM_DDRX			DDRC
#define SM_PORTX		PORTC
#define SM_PORT_MASK	0x3F // 6 BIT!!!!!!!!!!!!
#define SM_PORT_INIT()  (SM_DDRX |= SM_PORT_MASK)

#define MOTOR_ON 		0x01
#define MOTOR_DIRECTION 0x02
extern uint8_t gu8SM_Status;
extern void StartTimer_1(uint16_t u16Frq);

#endif  //MAIN_HEADER
