

#include <avr/sfr_defs.h>
#include <avr\io.h>
#include <util\delay.h>
#include <math.h>
#include <avr/wdt.h>
#include <avr\interrupt.h>
#include <stdlib.h> //itoa ultoa
#include <avr\pgmspace.h> // <--#include <progmem.h>
#include "StepMot-xWire.h"

volatile PGM_P gppmgPattern;
volatile uint8_t gu8Parser;  // *( Prser + nn )
volatile uint8_t gu8PatternSize; // Achtung eine 0 muss im Feld sein

const char MCA_ARDUINO_SM[] PROGMEM = {0x08,0x0C,0x04,0x06,0x02,0x03,0x01,0x09};	//CONST ARRAY
const char MCA_FULLSTEP[] PROGMEM = {0x3A, 0x39,0x35,36};
const char MCA_HALFSTEP[] PROGMEM = {0x3A,0x28,0x39,0x11,0x35,0x24,0x36,0x12};

uint8_t gu8SM_Status;


// ***** ***********************************************************
ISR( TIMER1_COMPA_vect )// signal handler	/#define SIG_OUTPUT_COMPARE1A	_VECTOR(6)
// ***** ***********************************************************
{
if( gu8SM_Status & MOTOR_DIRECTION )
	{
	SM_PORTX = pgm_read_byte_near(gppmgPattern + gu8Parser++ );
	}
else
	{
	SM_PORTX = pgm_read_byte_near( gppmgPattern + gu8Parser-- );
	};
gu8Parser %= gu8PatternSize;
};


// *********************************
void Start_STEPM_Timer_1(uint16_t u16Frq)
// *********************************
{
TCCR1B = 0;
TCNT1 = 0;
gu8SM_Status &= ~MOTOR_ON;
if( u16Frq )
	{
	gu8SM_Status |= MOTOR_ON;
	OCR1A = round( (F_CPU / 1024.0 ) / (float)u16Frq ); //Frequenz berechnen
	TIMSK1 = _BV(OCIE1A); //Interrupt
	TCCR1B = _BV( WGM12) | _BV( CS12) | _BV(CS10); //CTC + /1024
	gu8SM_Status |= MOTOR_ON;
	sei();
	}
else
	{
	TCCR1B = 0;
	TCNT1 = 0;
	gu8SM_Status &= ~MOTOR_ON;
	};
};

// **********************
void SelectStepMotType( uint8_t u8Type )
// **********************
{
switch( u8Type )
	{		
	case SMTYPE_FULLSTEP: 
		{
		gppmgPattern =  MCA_FULLSTEP ;
		gu8Parser = 0;
		gu8PatternSize = 4;
		break;
		};
	case SMTYPE_HALFSTEP: 
		{
		gppmgPattern =  MCA_HALFSTEP;
		gu8Parser = 0;
		gu8PatternSize = 8;
		break;
		};
	case SMTYPE_5POL_MINISTEP: 
		{
		gppmgPattern =  MCA_ARDUINO_SM;
		gu8PatternSize = 8;
		gu8Parser = 0;
		break;
		};
	}; //switch
};