
// Kommando SS, 1..6
// Ss,2<13>

//------------------------------------------------------------------------------
// Programmed by Christof Ermer
//------------------------------------------------------------------------------

#define SOFTWARE	"SEPTM-4Pol"
#define HARDWARE	"Arduino-UNO ATMega328"
#define DATUM		"05.04.2016 12:00"
#define AUTOR		"* Christof Ermer *"
#define IHAVENOBRAIN	"I have no brain"	
#define USEYOURS		"Use your own"

#include <avr/sfr_defs.h>
#include <avr\io.h>
#include <util\delay.h>
#include <avr/wdt.h>
#include <avr\interrupt.h>
#include <stdlib.h> //itoa ultoa
#include <avr\pgmspace.h> // <--#include <progmem.h>
#include <math.h>
#include "main.h"
#include "uart.h"
#include "Befehle.h"
#include "debug.h"
#include "ServiceFunc.h"
#include "StepMot-xWire.h"
//#include "max7219.h"

// GLOBALE VARIABLEN 

//char Bloedsinn[300+1];

volatile uint32_t gu32_Ticks;	 //  T2 TimerCounter
volatile uint8_t gu8Status;


#ifdef STATE_MACHINE_USED
volatile uint8_t gu8StateMach;
#endif


/// Interrupt Section
// ********************
ISR( TIMER2_OVF_vect )    //Dieser Vector steht in der iom328p.h
// ********************
{ 	// Interrupt Variablen mssen "volatile" deklariert sein
volatile static uint32_t u32Merke_T;
volatile static uint8_t u8Bremse;

//hochzhlen ? 244*/Sekunde
gu32_Ticks++;

if( ( (gu32_Ticks) - u32Merke_T) > 1 )
	{
	u32Merke_T = gu32_Ticks;	//neue Zeit merken
	gu8Status |= STATUS_TICK_EVENT;
	};

u8Bremse %= 10;
if( !(u8Bremse++))  // nicht so oft..
	{
	UART_TXRX_Check();  //langsam, aber sehen ob was kommt am UART
	};
};



#ifdef STATE_MACHINE_USED
// ********************************
void CheckStateMach(void)
// ********************************
{
switch( gu8StateMach )
	{
	case STATEMACH_NIX: 
		{
		break;
		};
		
	case STATEMACH_FULLSTEP: 
		{
		SelectStepMotType( SMTYPE_FULLSTEP );
		gu8StateMach = STATEMACH_NIX;
		break;
		};
	case STATEMACH_HALFSTEP: 
		{
		SelectStepMotType( SMTYPE_HALFSTEP );
		gu8StateMach = STATEMACH_NIX;
		break;
		};
	case STATEMACH_5POL_MINISTEP: 
		{
		SelectStepMotType( SMTYPE_5POL_MINISTEP );
		gu8StateMach = STATEMACH_NIX;
		break;
		};

	}; //switch
};
#endif
/*
// *************
void PotiTon(uint16_t u16Ton)
// *************
{
DDRB |= (1<<1);	//OC1A ausgang OCxx
TCCR1A = (1<<COM1A0);	// Toggle OC1A
TCCR1B = (1<<WGM12) | (1<< CS10); //1024	
OCR1A = u16Ton * 64;
};
*/



// *************
int main(void)
// *************
{
uint8_t u8NN = 0;
uint8_t u8Line;


wdt_reset();   //WATCHDOG!
wdt_enable(5); //500mS Totmannknopf

uart_init( UART_BAUD_SELECT_DOUBLE_SPEED(UART_BAUD_RATE, F_CPU) );
sei(); 
ResetRxBuff();

//TickCounter Starten
TCNT2=0;
TIMSK2 = (1 << TOIE2);	//Interrrupt aktivieren
sei(); //cli();
TCCR2B = (1 << CS21) | (1 << CS20);	//32 //Vorteiler 32 einschalten


uart_puts_p( PSTR( HARDWARE ));uart_putc(13); 
uart_puts_p(  PSTR( SOFTWARE ) );uart_putc(13);
uart_puts_p( PSTR( DATUM )  );uart_putc(13); 
uart_puts_p( PSTR( AUTOR ) );uart_putc(13); 
uart_puts_p( PSTR( IHAVENOBRAIN ) );uart_putc(13); 
uart_puts_p( PSTR( USEYOURS ) );uart_putc(13); 


SM_PORT_INIT();
SelectStepMotType( SMTYPE_FULLSTEP );
gu8SM_Status |= MOTOR_DIRECTION;
Start_STEPM_Timer_1(100);

gu8Status |= STATUS_TICK_MSG_FLAG;
gu8StateMach = STATEMACH_FULLSTEP;

CheckStateMach();
for(;;) 
	{
	sei();
	wdt_reset();	//WATCHDOG!

	
	if( gu8Status & STATUS_TICK_EVENT )
		{
		gu8Status &= ~STATUS_TICK_EVENT;
		
		//PORTB ^= LED1_BLINK;	// ab jetzt langsame ~1Hz Action				
		if( gu8Status & STATUS_TICK_MSG_FLAG ) //TO/TF
			{			
//			uart_puts( ultoa( ADC_10Bit(0), gcaStr, 10 ) );
//			PotiTon( ADC_10Bit(0) );
//			uart_putc( 13 );

			//uart_puts_p( PSTR("Speed=") );
			//uart_puts( ultoa( OCR1A, gcaStr, 10 ) );
			//uart_putc( 13 ); //CR
			};
			
		};
	CheckStateMach();
//Toggle_Bit(1);
	};
}; // main
