

//------------------------------------------------------------------------------
// Programmed by Christof Ermer
//------------------------------------------------------------------------------

//SYSINFO
#define DATUM		"4.03.2011"
#define FUNKTION	"ADC 10Bit Port A - Tastatur an PORTB"
#define HARDWARE	"Atmel ATMega16 V3.3"
#define UHRZEIT	"12:00"
#define AUTOR		"Christof Ermer"
#define BAUDRATE	"BAUD 9600 8N1"

#define IHAVENOBRAIN	"I have no brain."	
#define USEYOURS		"Use your own"

/*  HISTORY 
In Interupts...alle Vars deklarieren mit 
volatile uint32_t Tickscounter..
*/

#include <avr\io.h>
#include <ctype.h>
#include <inttypes.h>
#include <avr\pgmspace.h> // <--#include <progmem.h>

#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <avr\interrupt.h>  // obsolete #include <avr\signal.h>

//ACHTUNG STELLT OBSOLETE Procedure in header wieder her
//#include <compat\deprecated.h>
#include <util\delay.h>	//_delay_loop_1 _delay_loop_2 delay_ms
#include <avr\wdt.h>

#include "main.h"		//with Hardware assigns
#include "uart.h"
#include "rc5.h"

#ifdef INFRAROT_RC5_USED
void CHECK_IR_CODE(void);
#endif


#ifdef TIMER_TICK_USED
void StartTickTimer(void);	//0.1 Seconds  interrupt
#endif

#ifdef ADC_USED_ENABLED
uint16_t ADC_10Bit(uint8_t u8Chan);
#endif

#ifdef UART_USE_ENABLED
void UART_TXRX_Check(void);
void ResetRxBuff(void);
void PrintCR(void);

void PrintStrCR(const char* pStr);
void Print_PStrCR(PGM_P pmStr);
void CheckOrder(char* pcStr);
void LongToNumStr(int32_t lVal);
void PrintLongCR(int32_t lVal);
void FloatToNumStr(double fVal);
#endif

//CONSTANT ARRAYs IN .TEXT = ROM ARREA   .DATA IST SRAM !! .BSS SRAM
//const char MCA_DELIMTERSTR[] PROGMEM = { ',',0 };
// GLOBALE VARIABLEN 
uint8_t gu8ProgMode;
//MSG
const char MCA_DELIMITER[] PROGMEM	= ",";
const char MCA_ISTGLEICH[] PROGMEM	= "=";

const char MCA_ShiftLR[] PROGMEM = {0x01,0x02,0x04,0x08,0x10,0x20,0x40,0x80,0x40,0x20,0x10,0x08,0x04,0x02,};
const char MCA_STARTREK[] PROGMEM = {0x81,0x42,0x24,0x18,0x24,0x42};
const char MCA_Blink[] PROGMEM = {0xAA,0x55};

#ifdef UART_USE_ENABLED 
static char* gpcRxPars;
static char gcaRxStr[RX_STRMAX + 1]; //+1 for the 0
static char gcaNumStr[NUMMAX + 1]; //+1 for the 0
static char gcaStr[STRMAX + 1]; //+1 for the 0
static COMMAND_TYPE gsCmd;
#endif




//static uint8_t gcaSegmentStr[SEGMENTSTRMAX + 1]; //+1 for the 0
volatile  uint32_t gu32_Ticks; //  T2 timeCounter, only NN_Counter for Keypressings
#ifdef USE_ERROR_FLAG 
uint8_t gbErrorFlag;
#endif


#ifdef TIMER_TICK_USED 
// ****************************************************************
//volatile  SIGNAL(TIMER2_OVF_vect) //oder SIGNAL--INTERRUPT(SIG_OVERFLOW2) = mit SEI am Anfang
SIGNAL( TIMER2_OVF_vect ) //oder SIGNAL--INTERRUPT(SIG_OVERFLOW2) = mit SEI am Anfang
// *******************************************************************
{
sei();
//cli();/ 
gu32_Ticks++;
#ifdef UART_USE_ENABLED
UART_TXRX_Check();	//IMMER VORNAHANDEN !! IN ALLEN LOOPS DIE ZEIT BRAUCHEN
#endif
};
#endif

	

// *************************************
void StartTickTimer(void)	//0.1 Seconds  interrupt
//Normal MODE OC2 Disconnect Prescale 64
// *************************************
{
unsigned char sreg;
sreg = SREG; //loakaler Speicher
cli();
//TIMSK &=  (~(_BV(TOIE2)) & ~(_BV(OCIE2)));
TIMSK &= ~( TIMSK_TOIE2_FLAG | TIMSK_OCIE2_FLAG );
gu32_Ticks = 0;
OCR2 = 0;
TCNT2 = 0;  //Timer MAX = TOP Compare
TIFR |= TIFR_OCF2_OUTP_COMPARE_FLAG | TIFR_TOV2_TIMER_OVERFLOW_FLAG ; // zum lschen setzen!
//TIMER STARTS with Presscale Select = 64
TCCR2 = TCCR2_CLK_256;	// 0000 0100//Timer Counter CTRL -- NORMAL MODE=NO OCR2
//TCCR2 = TCCR2_CLK_0;	//
TIMSK |= TIMSK_TOIE2_FLAG; //_BV(TOIE2); // BESSER == OVERFLOW 
SREG = sreg;
sei();
};


#ifdef ADC_EXTERNREF_USED_ENABLED
/*
// PRESCALER 3,6864 /  32 = 115200 50-200Khz gewnscht
// REM ADC4-ADC5 = 8 BIT;
// 4+2 Channel. 
//  ADC_INTERN-----ADC_INTERN-----ADC_INTERN---ADC_INTERN-----ADC_INTERN-----
*/
//****************************************************************
uint16_t ADC_10Bit(uint8_t ucChan)
//****************************************************************
{
DDRA &= ~(1<<ucChan);   //port A Chanel Bit Input  
PORTA &= ~(1<<ucChan); //Wegen Pullup abschalten
  // Activate ADC with Prescaler 16 --> 16Mhz/128 = 125 khz
ADCSRA = _BV(ADEN) | _BV(ADPS2) | _BV(ADPS1) |_BV(ADPS0);  
 // Select pin ADC0 using MUX
ADMUX = (ucChan & ADC_MUX_MASK); 
    //Start conversion
ADCSRA |= _BV(ADSC);   
while (ADCSRA & _BV(ADSC) ) // wait until converstion completed
	{
	wdt_reset();
	};	   
return ADC;// get converted value
};
#endif


#ifdef ADC_USED_ENABLED //INTERNREF 2.5V
//****************************************************************
uint16_t ADC_10Bit(uint8_t u8Chan) // 0..7
//****************************************************************
{
DDRA &= ~_BV(u8Chan);  //Bit loeshcne von port A,Chanel Bit Input  
PORTA &= ~_BV(u8Chan); //Wegen Pullup abschalten
//Activate ADC with Prescaler 16 --> 16Mhz/128 = 125 khz
//ADCSRA = _BV(ADEN) | _BV(ADPS2) | _BV(ADPS1) |_BV(ADPS0);  
//MIT INTERNER REFERENCE
ADCSRA = ADCSRA_ADEN | ADCSRA_PRESCALER_128;   //ADC EIN UND PreScaler
ADMUX = ADMUX_REFS1 | ADMUX_REFS0 | u8Chan;	// ADMUX_REFS0 Select pin ADCx using MUX  
_delay_us(1);
ADCSRA |= ADCSRA_ADSC;	//ADCSRA |= _BV(ADSC);	//Start conversion
while( ADCSRA & ADCSRA_ADSC )	//wait until _BV(ADSC)=0 =converstion completed
	{
	//wdt_reset();
	};	
return ADC;	//ADCW; //get converted value
};
#endif


#ifdef ADC_USED_ENABLED
// *******************************************
float PotiSkalierung( uint16_t u16Poti )	//Normiert Poti mit Offset auf 0..1 von 0..1000
//liefert Fakot 0..1 zurck wenn nix zu tun, rweturn -1;
// *******************************************
{
if( (u16Poti > POTI_ZERO_OFFSET ) && (u16Poti < POTI_UPPER_LIMIT) )
	{
	return ((u16Poti - POTI_ZERO_OFFSET) / (float)POTI_RANGE_LIMIT);
	};
return -1;	
};
#endif


#ifdef UART_USE_ENABLED 
// *******************************************************************
void UART_TXRX_Check(void)
/*	
* Get received character from ringbuffer
* uart_getc() returns in the lower byte the received character and
* in the higher byte (bit_MSK) the last receive error
* UART_NO_DATA is returned when no data is available.
*/
// *******************************************************************
{
uint16_t uiRxUart;
uiRxUart = uart_getc();//!FETCH ALLWAYS BYTE FROM RX RINGBUFF INTERRUPT!
if ( !(uiRxUart & UART_NO_DATA) )  //0x0100
	{
//   * new data available from UART
//  * check for Frame or Overrun error
#ifdef UART_ERRORMSG 
	if ( uiRxUart & (UART_FRAME_ERROR | UART_OVERRUN_ERROR | UART_BUFFER_OVERFLOW) )
		{
		ResetRxBuff();
		uart_init( UART_BAUD_SELECT(UART_BAUD_RATE, F_CPU) );// !! Init UART interface
// Framing Error detected, i.e no stop bit detected
		Print_PStrCR(  PSTR("UartErr") );
		};
#endif
//NOW SELCT ACTION FROM ORDER
//Check CR
	if(gpcRxPars < (gcaRxStr + RX_STRMAX))	//ENDANSCHLAG ERREICHT ?
		{
		switch( (unsigned  char)uiRxUart  )
			{
			case 13: // order!! from Terminal
				{
				CheckOrder(gcaRxStr);//gcaRxStr = accumulated str
				ResetRxBuff();
				break;
				};	           				
			default: //Accumulate
				{
      // Accumulate String only to gcaRxStr with uiAAA Parser
				*gpcRxPars++ = (unsigned  char)(uiRxUart & 0x0FF);//Append rxByte
				*gpcRxPars = 0; //ZERO carry
				};
			};//switch
		}// if (pcRxPars < (gcaRxStr + RXSTRMAX))
	else  // To much data Rx, than clear simple all
		{
	 //overflow of RX clears all
		ResetRxBuff();	// Clear Rx Parspointer in Buff an terminate RxStr with 0
		};//if(gpcRxPars < (gcaRxStr + RXSTRMAX))
// ENDE DER RX EMPFANGSAUSWERTUNG
	};
};
#endif


#ifdef UART_USE_ENABLED 
// *******************************************************************
void ResetRxBuff(void)
// *******************************************************************
{
gpcRxPars = gcaRxStr; // Set parse pointer back;
*gpcRxPars = 0;	//clear Rx
};
#endif

#ifdef UART_USE_ENABLED   //MAKLEFILE ANPASSEN

#define FLOAT_PRAEDIGITS_MAX	6 // DIgits nach //dtostrf(fVal,NUMMAX, DIGITS_MAX, gcaNumStr);
#define FLOAT_DIGITS_MAX		3 // DIgits nach //dtostrf(fVal,NUMMAX, DIGITS_MAX, gcaNumStr);
// *******************************************************************
void PrintCR(void)
// *******************************************************************
{
uart_putc( ASC_CR );
};

// *******************************************************************
void PrintStrCR(const char* pStr)
// *******************************************************************
{
uart_puts(pStr);
PrintCR();
};


// *******************************************************************
void Print_PStrCR(PGM_P pmStr)
// *******************************************************************
{
uart_puts_p(pmStr);
PrintCR();
};

// **********************************************
void FloatToNumStr(double fVal)
// *************
{
dtostrf(fVal, FLOAT_PRAEDIGITS_MAX, FLOAT_DIGITS_MAX, gcaNumStr ); //[-]d.ddd
};

// **********************************************
void LongToNumStr(int32_t lVal)
// **********************************************
{ 
ltoa(lVal, gcaNumStr, 10 );
};

// **********************************************
void ULongToNumStr(uint32_t ulVal)
// **********************************************
{ 
ultoa(ulVal, gcaNumStr, 10 );
};


// *******************************************************************
void PrintLongCR(int32_t lVal)
// *******************************************************************
{
LongToNumStr(lVal); PrintStrCR(gcaNumStr);
};

void PrintULongCR(uint32_t ulVal)
// *******************************************************************
{
ULongToNumStr(ulVal); PrintStrCR(gcaNumStr);
};

// *******************************************************************
void PrintFloatCR(double fVal)
// *******************************************************************
{
FloatToNumStr(fVal); PrintStrCR(gcaNumStr);
};
#endif



// *******************************************************************
void CheckOrder(char *pcStrOrder) //von gcaRxStr
// *******************************************************************
{ //INPUT ERWARTET INDER FOR "BEFEHL,WERT" BSP: "SFR,1000"
//uint16_t uiCnt =0;
char * pStrTok; // fr strtok_r
char * pucCh = &pcStrOrder[ strlen(pcStrOrder) ]; // Stelle POINTER auf \0 Ende  // kein unsigned char*

strcpy(gcaStr, pcStrOrder);
strcpy_P(gcaNumStr, MCA_DELIMITER); //HILFSWEISE gcaNumStr fr ","

if( (pStrTok = strtok_r( pcStrOrder, gcaNumStr  , &pucCh)) != NULL)//Trenne CMD, von ID, -"$$$1,CMD
	{	
	strcpy(gsCmd.ucaCmd, pStrTok);
	}
else
	{
	*gsCmd.ucaCmd = 0;
	};
gsCmd.ucaCmd[ COMAMNDSIZEMAX ] = 0; //Sicherheitsterminierung COMAMNDSIZEMAX=10


//strcpy(gcaStr, pcStrOrder);

gsCmd.fCmdVal_1 = gsCmd.fCmdVal_2 = 0;
if( (pStrTok = strtok_r( NULL,  gcaNumStr, &pucCh)) != NULL)
	{
	gsCmd.fCmdVal_1 = atof(pStrTok);// Und dann TO Float	
	};
	
if( (pStrTok = strtok_r( NULL,  gcaNumStr, &pucCh)) != NULL)
	{
	gsCmd.fCmdVal_2 = atof(pStrTok);// Und dann TO Float	
	};

//========================================================================================

if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("PING") )  )
	{	
	Print_PStrCR( PSTR("PONG") );	
	};

if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("XX") )  )
	{	
	PrintLongCR( gu32_Ticks );
	};

if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("LL") )  )
	{	
	gu8ProgMode |= STATE_FLAG_LINKSRUM;
	Print_PStrCR( PSTR("* Linksrum *") );
	
	};

#ifdef ADC_USED_ENABLED
if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("ADC") )  )    //ADC,0..7
	{	
	uart_puts_p( PSTR("ADC") );
	uart_puts_p( MCA_ISTGLEICH );	
	PrintLongCR( ADC_10Bit( gsCmd.fCmdVal_1 ) );
	};
#endif


if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("RR") )  )
	{	
	gu8ProgMode &= ~ STATE_FLAG_LINKSRUM;
	Print_PStrCR( PSTR("* Rechtsrum *") );	
	};
 };




#ifdef INFRAROT_RC5_USED
// ****************************************************************
void CHECK_IR_CODE(void)
// ****************************************************************
{	

if( gstRC5.code )
	{
	PrintLongCR( gstRC5.code );
	};
					
switch (gstRC5.code)
	{	
	case STANDBY:
	case STANDBYOFF_KEY:
		{
		break;
		}

	case IR_NULL :
		{
		DDRC = 0xFF;
		PORTC = 0xA5;
		break;
		};

	case IR_EINS :
		{
		DDRC = 0xFF;
		PORTC = 0x5A;
		break;
		};
	case VOLUME_M :
		{
		break;
		};
	case VOLUME_P	 :
		{
		break;
		};		
	case BRIGHT_M :
		{
		break;
		};
	case BRIGHT_P :
		{
		break;
		};
	case START :
		{
		break;
		};
	case STOP :
		{
		break;
		};	
	case COLOUR_SATURATION_P :
		{	
		break;
		};	
	case COLOUR_SATURATION_M :
		{	
		break;
		};	
	case BILDSUCHLAUF_ZURUECK :
		{	
		break;
		};	
	case  BILDSUCHLAUF_VORWAERTS :
		{	
		break;
		};
	}; //switch
gstRC5.u8RC5_State_Flags = RC5_EVENT_DONE_FLAG;
gstRC5.u32EventTime = gu32_Ticks;
};
#endif


// *******************************************************************
// *******************************************************************
int main(void)
// *******************************************************************
// *******************************************************************
{
static uint32_t u32Now;
//uint8_t u8NN;
//uint8_t u8Led;
//INITS
cli();//The global interrupt flag is maintained in the I bit of the status register (SREG).  
//Wichtige Schritte.. so bald wie mglich

//INIT HARDWARE
//USing of PORTOUTS  1=OUT, 0=IN
DDRA = PORTA_DDRX_OUT_MSK;
PORTA = PORTA_PRESET_PULL_MSK;
DDRB = PORTB_DDRX_OUT_MSK;
PORTB = PORTB_PRESET_PULL_MSK;
DDRC = PORTC_DDRX_OUT_MSK;
PORTC = PORTC_PRESET_PULL_MSK;
DDRD = PORTD_DDRX_OUT_MSK;
PORTD = PORTD_PRESET_PULL_MSK;

gu32_Ticks = 0;
u32Now = 0;

//SFIOR = (1<<PUD); //Pullup Disable

StartTickTimer();	//8 Bit Timer 2 = MS Tick Counter
//Pointer and Strings init
wdt_enable(WDTO_2S); //Set 1.9Sec WatchDog ENABLE
wdt_reset();   //WATCHDOG!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

// Initialize UART library, pass baudrate and avr cpu clock
// with the macro UART_BAUD_SELECT()
ResetRxBuff();
uart_init( UART_BAUD_SELECT(UART_BAUD_RATE, F_CPU) );

Print_PStrCR( PSTR(HARDWARE) );
Print_PStrCR( PSTR(AUTOR) );
Print_PStrCR( PSTR(FUNKTION) );
Print_PStrCR( PSTR(DATUM) );
Print_PStrCR( PSTR(BAUDRATE) );
Print_PStrCR( PSTR(IHAVENOBRAIN) );
Print_PStrCR( PSTR(USEYOURS) );
	

#ifdef INFRAROT_RC5_USED
//MCUCR = MCUCR_INT1_FALLING_EDGE; //ISC00=0;  FALLING EDGE --> INT0, INT1   //NICHT mit MCUCSR verwechseln !
rc5_init(RC5_ALL);
gstRC5.u8RC5_State_Flags = RC5_READY_FLAG;
gstRC5.u8RC5_State_Flags = RC5_EVENT_DONE_FLAG;
gstRC5.u32EventTime =gu32_Ticks;
#endif


//DDRC = 0xFF;
// ************ MAIN LOOP *********************
for(;;)  /* loop forever */ //Aber schnell > 200.000 mal/Sekunde
// ************ MAIN LOOP *********************
	{	
	sei();
 	wdt_reset();	//WATCHDOG!
	
	
	if( (gu32_Ticks - u32Now ) > 244 ) //Hier kann was gemacht werden jede 1/10 Sekunde
		{
		u32Now = gu32_Ticks; //Zeit merken !!	
/*
		uart_puts_p( PSTR("ADC-Ch0") );
		uart_puts_p( MCA_ISTGLEICH );	
		PrintLongCR( ADC_10Bit( 0 ) );	
*/
		};

#ifdef INFRAROT_RC5_USED
	if( (gstRC5.flip != -1) && 
		(gstRC5.u8RC5_State_Flags == RC5_READY_FLAG)
	)
		{
		gstRC5.u8RC5_State_Flags = RC5_EVENT_FLAG;

/*
lcd_gotoxy(0,1);
lcd_puts_p( PSTR("                ") );	
LongToNumStr( gstRC5.code );
lcd_puts_p( PSTR("LCD=") );	
lcd_gotoxy(0,1);
lcd_puts( gcaNumStr );
*/
		CHECK_IR_CODE();
		};

	if( (gstRC5.u8RC5_State_Flags & RC5_EVENT_DONE_FLAG)  &&  //Waitloop
		( (gu32_Ticks - gstRC5.u32EventTime) > IR_RELEASE_WAIT_TIME_TICKS)//100 //4mS * 25 = 100mS
	)
		{
		gstRC5.flip = -1;
		//gstRC5.code = 0;		
		gstRC5.u8RC5_State_Flags = RC5_READY_FLAG;	//Waitloopveriegelung lschen
		};
#endif


	}; //main loop Ende
};
// ******************* MAIN END ********************************************
