
// Kommando SS, 1..6
// Ss,2<13>

//------------------------------------------------------------------------------
// Programmed by Christof Ermer
//------------------------------------------------------------------------------

#define SOFTWARE	"Einfache Textausgabe"
#define HARDWARE	"Arduino-UNO ATMega328"
#define DATUM		"28.03.2016 12:00"
#define AUTOR		"* Christof Ermer *"
#define IHAVENOBRAIN	"I have no brain"	
#define USEYOURS		"Use your own"

#include <avr/sfr_defs.h>
#include <avr\io.h>
#include <util\delay.h>
#include <avr/wdt.h>
#include <avr\interrupt.h>
#include <stdlib.h> //itoa ultoa
#include <avr\pgmspace.h> // <--#include <progmem.h>
#include <math.h>

#include "main.h"
#include "uart_328.h"
#include "Befehle.h"
//#include "debug.h"

// GLOBALE VARIABLEN 
volatile uint32_t gu32_Ticks;	 //  T2 TimerCounter
volatile uint8_t gu8Status;


// Interrupt Section
// ********************
ISR( TIMER2_OVF_vect )    //Dieser Vector steht in der iom328p.h
// ********************
{ 	// Interrupt Variablen mssen "volatile" deklariert sein
volatile static uint32_t u32Merke_T;

//hochzhlen ? 244*/Sekunde
gu32_Ticks++;

if( ( (gu32_Ticks) - u32Merke_T) > TICK_1000MS ) 	// 244* pro Sekunde
	{
	u32Merke_T = gu32_Ticks;	//neue Zeit merken
	gu8Status |= STATUS_TICK_EVENT;
	};

if( !(gu32_Ticks % 25) ) // Nur jede 1/10  Sekunde.. das reicht. 
	{
	UART_TXRX_Check();  //langsam, aber sehen ob was kommt am UART
	};
};



// *************
int main(void)
// *************
{
//uint8_t u8NN = 0;

wdt_reset();   //WATCHDOG!
wdt_enable(5); //500mS Totmannknopf

cli();
uart_init( UART_BAUD_SELECT_DOUBLE_SPEED(UART_BAUD_RATE, F_CPU) );
ResetRxBuff();
sei(); 

//TickCounter Starten
TCCR2B = (1 << CS22) | (1 << CS21);	//Vorteiler //256 einschalten
TIMSK2 = (1 << TOIE2);	//Interrrupt aktivieren

sei();
uart_puts_p( PSTR( HARDWARE ));uart_putc(13); 
uart_puts_p(  PSTR( SOFTWARE ) );uart_putc(13);
uart_puts_p( PSTR( DATUM )  );uart_putc(13); 
uart_puts_p( PSTR( AUTOR ) );uart_putc(13); 
uart_puts_p( PSTR( IHAVENOBRAIN ) );uart_putc(13); 
uart_puts_p( PSTR( USEYOURS ) );uart_putc(13); 


gu8Status |= STATUS_TICK_MSG_FLAG;

for(;;) 
	{
	sei();
	wdt_reset();	//WATCHDOG!
	
	if( gu8Status & STATUS_TICK_EVENT )
		{
		gu8Status &= ~STATUS_TICK_EVENT;
		
		//PORTB ^= LED1_BLINK;	// ab jetzt langsame ~1Hz Action				
		if( gu8Status & STATUS_TICK_MSG_FLAG ) //TO/TF
			{
			uart_puts_p( PSTR("Tick=") );			
			uart_puts( ultoa( gu32_Ticks, gcaNumStr, 10 ) );
			uart_putc( 13 ); //CR
			};
			
		};
	};
}; // main
