#ifndef DS1337_HEADER
	#define  DS1337_HEADER

	#define BYTE_DEC_TRANSFORM_USED


//ACHTUNG SHIFT ADRESSE = 7BIT nicht vergessen
//#define DS1337_ADR	(0x68 << 1) // 7 Bit 01101000
#define DS1337_ADR	(0xD0) // 7 Bit 1101000(R/W)
/*
0x68 = Data WriteSlave Receiver Mode
0x68 = Data Read (from Current Pointer Location)Slave Transmitter Mode
0x68 Data Read (Write Pointer, Then Read)Slave Receive and Transmit
0xD8 = Data Read (from Current Pointer Location)Slave Transmitter Mode
Data Read (Write Pointer, Then Read)Slave Receive and Transmit
*/

//Addresses Seite 8 im DS1337 PDF

typedef struct
{
uint8_t u8Second;
uint8_t u8Minutes;
uint8_t u8Hour;
uint8_t u8Day;
uint8_t u8Date;
uint8_t u8Month;
uint8_t u8Year;
}RTCTime_t;

typedef struct
{
uint8_t u8Second;
uint8_t u8Minutes;
uint8_t u8Hour;
uint8_t u8DayDate;
}RTCAlarm_1_Time_t;

typedef struct
{
uint8_t u8Minutes;
uint8_t u8Hour;
uint8_t u8DayDate;
}RTCAlarm_2_Time_t;


#define RTC_YEAR_DEFAULT	14
#define RTC_MONTH_DEFAULT	05
#define RTC_DAY_DEFAULT		01


// Special Purpose Regsiter
//Status Register (0Fh)
#define SPR_A1IE	0
#define SPR_A2IE	1
#define SPR_INTCN	2
#define SPR_RS1		3
#define SPR_RS2		4
#define SPR_EOSC	7



//TIMEKEEPER REGISTERS  SEITE 8 PDF
#define SECONDS	0X00
#define MINUTES	0X01
#define HOUR	0X02
#define	DAY		0X03
#define DATE	0X04
#define MONTH	0X05
#define YEAR	0X06

#define ALARM1_SECONDS	0X07
#define ALARM1_MINUTES	0X08
#define ALARM1_HOUR	0X09

#define ALARM1_DAY_DATE	0X0A
#define ALARM2_MINUTES	0x0B
#define ALARM2_HOUR	0x0C
#define ALARM2_DAY_DATE	 0x0D

#define	CONTROL	0x0E
#define	STATUS	0x0F

extern RTCTime_t gstRTCTime;
extern RTCAlarm_1_Time_t gstRTCAlarm_1_Time;
extern RTCAlarm_2_Time_t gstRTCAlarm_2_Time;

extern uint8_t gu8aTimeKeeperReg[16];


extern int8_t RTC_DS1337_Init(void);
extern void DS1337_Read_Full( void );

#ifdef BYTE_DEC_TRANSFORM_USED
extern int bcd(int dec);
extern int decimal(int bcd);
#endif


#endif //DS1337_HEADER
