

/*
93-I2C-LCD-Modul_PCF8574
*/

//------------------------------------------------------------------------------
// Programmed by Christof Ermer
//------------------------------------------------------------------------------

#define SOFTWARE	">UNO-R3 I2C-LCD http:"
#define HARDWARE	"Arduino-UNO ATMega328"
#define DATUM		"02.02.2015 12:00"
#define AUTOR		"* Christof Ermer *"
#define IHAVENOBRAIN	"I have no brain"	
#define USEYOURS		"Use your own"

#include <avr/sfr_defs.h>
#include <avr\io.h>
#include <util\delay.h>
#include <avr/wdt.h>
#include <avr\interrupt.h>
#include <stdlib.h>
#include <avr\pgmspace.h> // <--#include <progmem.h>
#include "main.h"
#include "uartATM328.h"
#include "Befehle.h"
#include "max7219.h"
#include "PCF8574.h"
#include "debug.h"

#include "i2cmaster.h"
#include "i2clcd.h"

// GLOBALE VARIABLEN 
volatile uint32_t gu32_Ticks;	 //  T2 TimerCounter
volatile uint8_t gu8Status;
const char MCA_LCD_16SPACE[] PROGMEM = "                ";  // 16 Leer Stellen

// Interrupt Section
// ********************
ISR( TIMER2_OVF_vect )    //Dieser Vector steht in der iom328p.h
// ********************
{ 	// Interrupt Variablen mssen "volatile" deklariert sein
volatile static uint32_t u32MerkeT;
Toggle_Bit(1);

//hochzhlen ? 244*/Sekunde
if( ( (gu32_Ticks++) - u32MerkeT) > TICK_500MS )
	{
	u32MerkeT = gu32_Ticks;	//neue Zeit merken
	gu8Status |= STATUS_TICK_EVENT;
	};
// !! 244*/ Sekunde	
UART_TXRX_Check();  //langsam, aber sehen ob was kommt am UART
};


// *************
int main(void)
// *************
{

uint8_t u8Val;
uint8_t u8NN = 0;
uint32_t u32MainloppCnt = 0;

DDRB |= LED1_BLINK;	     //Bit 0 von PORTC als Ausgang

wdt_reset();   //WATCHDOG!
wdt_enable(5); //500mS Totmannknopf

uart_init( UART_BAUD_SELECT_DOUBLE_SPEED(UART_BAUD_RATE, F_CPU) );
sei(); 
ResetRxBuff();

//TickCounter Starten
TCCR2B = (1 << CS22) | (1 << CS21);	//Vorteiler //256 einschalten
TIMSK2 = (1 << TOIE2);	//Interrrupt aktivieren

sei();
uart_puts_p( PSTR( HARDWARE ));uart_putc(13); 
uart_puts_p(  PSTR( SOFTWARE ) );uart_putc(13);
uart_puts_p( PSTR( DATUM )  );uart_putc(13); 
uart_puts_p( PSTR( AUTOR ) );uart_putc(13); 
uart_puts_p( PSTR( IHAVENOBRAIN ) );uart_putc(13); 
uart_puts_p( PSTR( USEYOURS ) );uart_putc(13); 


// TWI initialisieren
	i2c_init();

MAX7219_Init();
MAX7219_Clear();	


	// LCD initialisieren
	lcd_init();

	// LCD-Anzeige loeschen
	lcd_command(LCD_CLEAR);
	
	// Hintergrundbeleuchtung an
	lcd_backlight(ON);


// Text auf LCD ausgeben
// MIT RAM , als falsch
strcpy_P( gcaStr, PSTR("* I2C LCD *") );
	lcd_printlc(1,1,(unsigned char *)gcaStr);
strcpy_P( gcaStr, PSTR("*Christof Ermer*"));
	lcd_printlc(2,1,(unsigned char *)gcaStr);

MAX7219_Init();
MAX7219_Clear();

//gu8Status = 0;;
gu8Status |= STATUS_TRIGGER_OUTPUT;

for(;;) 
	{
	sei();
	wdt_reset();	//WATCHDOG!
	
	u32MainloppCnt++;
	
	if( gu8Status & STATUS_TICK_EVENT )
		{		
		gu8Status &= ~STATUS_TICK_EVENT;
		
		PORTB ^= LED1_BLINK;	// ab jetzt langsame ~1Hz Action

		strcpy_P(gcaStr, MCA_LCD_16SPACE);
		lcd_printlr(1,1,(unsigned char *)gcaStr);
		lcd_printlr(2,1,(unsigned char *)gcaStr);

//Zeige TICK
		ultoa( gu32_Ticks, gcaStr, 10 );
		lcd_printlr(1,1,(unsigned char *)gcaStr);

//Zeige mainloops/Sekeunde
		strcpy_P( gcaStr, PSTR("loop/s:"));
		lcd_printlc(2,1,(unsigned char *)gcaStr);
	
		ultoa( u32MainloppCnt, gcaStr, 10 );
		lcd_printlr(2,8,(unsigned char *)gcaStr);

/*		i2c_start_wait(PCF8574_ADR_PREFIX + I2C_WRITE );
		
		if( i2c_write( (1<< u8Count) ) )
			{
			uart_puts_p( PSTR("Write failed") ); 
			uart_puts_p( PSTR(" Byte=") ); 
			uart_puts(ByteToBin( (1<< u8Count) ) );
			uart_putc( 13 );
			};
		i2c_stop ();
		};
*/
		///u8Val = (uint8_t)(1 << (gu32_Ticks % 8));

		u8Val = ( 1 << (u8NN % 8) );
		u8NN++;
		MAX7219_Clear();
		MAX7219_Write(1, u8Val);

		if( gu8Status & STATUS_TRIGGER_OUTPUT )
			{
			ultoa( u32MainloppCnt, gcaStr, 10 );
u32MainloppCnt=0;
			uart_puts_p(PSTR("Mainloops="));		
			uart_puts( gcaStr );
			uart_puts_p(PSTR("  Tick="));
			ultoa( gu32_Ticks, gcaStr, 10 );
			uart_puts( gcaStr );			
			uart_putc( 13 );			
			};
		};

//Toggle_Bit(1);
	};
}; // main
