#ifndef _DS1302_H
	#define _DS1302_H
//https://www.mikrocontroller.net/mc-project/Pages/AVR/Programme/Programme.html

#include <avr/io.h>
#include <delay.h>

/*connection settings*/
#define RTC_CLK		0
#define RTC_IO		1
#define RTC_RST		2

#define RTC_DDR		DDRB
#define RTC_PORT	PORTB
#define	RTC_PIN		PINB

/*command settings*/
#define SEC				0
#define MIN				1
#define HR				2
#define DATE			3
#define MONTH			4
#define DAY				5
#define YEAR			6
#define CONTROL			7
#define TRICKLECHARGE	8
//#define CLOCKBURST		31

/*RAM may be used, if neccessary*/
/*	#define RAM0		32
	#define RAM1		33
	#define RAM2		34
	...
	...
	...
	#define RAM30		62
	#define RAMBURST	63
*/

/*global*/
typedef struct ds1302_data
{
	unsigned short sec_l;
	unsigned char sec_h;
	unsigned char min_l;
	unsigned char min_h;
	unsigned char hr_l;
	unsigned char hr_h;
	unsigned char date_l;
	unsigned char date_h;
	unsigned char month_l;
	unsigned char month_h;
	unsigned char day;
	unsigned char year_l;
	unsigned char year_h;
}UHRDATA_T ;
/*write byte in specified register*/
void ds1302_write(unsigned char command);

/*read byte out of specified register*/
unsigned char ds1302_read(void);

/*low-level-routine which writes byte*/
void write_byte(unsigned char,unsigned char);

/*low-level-routine which reads byte*/
unsigned char read_byte(unsigned char);

/*get date and time -> data ist given to struct*/
void ds1302_get_data (void);

/*set date and time*/
void ds1302_set_data (void);
extern UHRDATA_T gsUhrData;

#endif

