

/* Programmed by Christof Ermer 10.10.2014 */

#ifndef DS1302_HEADER
#define  DS1302_HEADER
/*
*********************************************************************************************************
* Module     : DS1302.H
* Author     : Randy Rasa
* Description: Header file for DS1302.C (LED Display Driver Routines)
*********************************************************************************************************
*/

/*
*********************************************************************************************************
* Constants
*********************************************************************************************************
*/

typedef struct
{
uint8_t u8Stunde;
uint8_t u8Minute;
uint8_t u8Sekunde;
uint8_t u8Tag;
uint8_t u8Monat;
uint8_t u8Jahr;
}TIME_T;

#define DS1302_DDRX		DDRB
#define DS1302_PORTX	PORTB
#define DS1302_PINX		PINB
#define DS1302_CLK		(1<<0)
#define DS1302_IO		(1<<1)
#define DS1302_RST		(1<<2)

#define  DS1302_RW			0x01
#define  DS1302_ADR_MASK	0x37
#define  DS1302_RC			0x40
#define  DS1302_ONE			0x80

/*
*********************************************************************************************************
* Macros
*********************************************************************************************************
*/

//Nur wenn alle Drei bit auf selben Port
#define INIT_DS1302_DIR()	( DS1302_DDRX |= DS1302_CLK | DS1302_IO | DS1302_RST )

#define SET_DS1302_CLK()  ( DS1302_PORTX |= DS1302_CLK )
#define CLR_DS1302_CLK()  ( DS1302_PORTX &= ~DS1302_CLK )

#define SET_DS1302_IO()  ( DS1302_PORTX |= DS1302_IO )
#define CLR_DS1302_IO()  ( DS1302_PORTX &= ~DS1302_IO )

#define SET_DS1302_RST()  ( DS1302_PORTX |= DS1302_RST )
#define CLR_DS1302_RST()  ( DS1302_PORTX &= ~DS1302_RST )

/*
*********************************************************************************************************
* Public Function Prototypes
*********************************************************************************************************
*/
extern uint16_t DS1302_Write( uint16_t u16Val);
#endif //DS1302_HEADER