
// Kommando SS, 1..6
// Ss,2<13>

//------------------------------------------------------------------------------
// Programmed by Christof Ermer
//------------------------------------------------------------------------------

#define SOFTWARE	"DS1302"
#define HARDWARE	"Arduino-UNO ATMega328"
#define DATUM		"04.04.2016 12:00"
#define AUTOR		"* Christof Ermer *"
#define IHAVENOBRAIN	"I have no brain"	
#define USEYOURS		"Use your own"

#include <avr/sfr_defs.h>
#include <avr\io.h>
#include <util\delay.h>
#include <avr/wdt.h>
#include <avr\interrupt.h>
#include <stdlib.h> //itoa ultoa
#include <avr\pgmspace.h> // <--#include <progmem.h>
#include <math.h>
#include "main.h"
#include "uart.h"
#include "Befehle.h"
#include "debug.h"
#include "DS1302.h"
#include "OutPort74-595.h"

// GLOBALE VARIABLEN 

volatile uint32_t gu32_Ticks;	 //  T2 TimerCounter
volatile uint8_t gu8Status;

// Interrupt Section
// ********************
ISR( TIMER2_OVF_vect )    //Dieser Vector steht in der iom328p.h
// ********************
{ 	// Interrupt Variablen mssen "volatile" deklariert sein
volatile static uint32_t u32Merke_T;
volatile static uint32_t u32PWM_T;
//hochzhlen ? 244*/Sekunde
gu32_Ticks++;

if( ( (gu32_Ticks) - u32Merke_T) > 244 )
	{
	u32Merke_T = gu32_Ticks;	//neue Zeit merken
	gu8Status |= STATUS_TICK_EVENT;
	};
	
if( ( (gu32_Ticks) - u32PWM_T) > 24 )
	{
	u32PWM_T = gu32_Ticks;	//neue Zeit merken
	gu8Status |= STATUS_FAST_T_FLAG;
	};	
// !! 244*/ Sekunde	
sei();
UART_TXRX_Check();  //langsam, aber sehen ob was kommt am UART
};

// *************
int main(void)
// *************
{
uint8_t u8NN = 0;
uint8_t u8Line;



wdt_reset();   //WATCHDOG!
wdt_enable(5); //500mS Totmannknopf

uart_init( UART_BAUD_SELECT_DOUBLE_SPEED(UART_BAUD_RATE, F_CPU) );
sei(); 
ResetRxBuff();

//TickCounter Starten
TCNT2=0;
TIMSK2 = (1 << TOIE2);	//Interrrupt aktivieren
sei(); //cli();
TCCR2B = (1 << CS21) | (1 << CS20);	//32 //Vorteiler 32 einschalten


uart_puts_p( PSTR( HARDWARE ));uart_putc(13); 
uart_puts_p(  PSTR( SOFTWARE ) );uart_putc(13);
uart_puts_p( PSTR( DATUM )  );uart_putc(13); 
uart_puts_p( PSTR( AUTOR ) );uart_putc(13); 
uart_puts_p( PSTR( IHAVENOBRAIN ) );uart_putc(13); 
uart_puts_p( PSTR( USEYOURS ) );uart_putc(13); 

gu8Status = 0;

for(;;) 
	{
	sei();
	wdt_reset();	//WATCHDOG!

	if( gu8Status & STATUS_FAST_T_FLAG)  // schnellere Aufruf
		{
		gu8Status &= ~STATUS_FAST_T_FLAG;		
		};

	
	if( gu8Status & STATUS_TICK_EVENT )
		{
		gu8Status &= ~STATUS_TICK_EVENT;
		
		if( gu8Status & STATUS_TICK_MSG_FLAG ) //TO/TF
			{	
			};
		
		};
//Toggle_Bit(1);
	};
}; // main
