
//------------------------------------------------------------------------------
// Programmed by Christof Ermer
//------------------------------------------------------------------------------
#define SOFTWARE	"Taster-LED"
#define HARDWARE	"Arduino-UNO ATMega328"
#define DATUM		"30.03.2016 12:00"
#define AUTOR		"=/\= Christof Ermer =/\= "
#define IHAVENOBRAIN	"I have no brain"	
#define USEYOURS		"Use your own"

#include <avr/sfr_defs.h>
#include <avr\io.h>
#include <util\delay.h>
#include <math.h>

#include "main.h"
#include "MAX543.h"
#include "LEDLeiste.h"

#define SINE_MODE 		0x01
#define SAW_UP_MODE		0x02
#define TRIANGLE_MODE	0x04
#define SQUARE_MODE		0x08
#define TEST_MODE		0x10


uint8_t gu8Mode = SINE_MODE;
uint8_t	gu8Level = 127;
// *******************
int main(void)
// *******************
{
uint16_t u16NN=0;
uint16_t u16Signal;
EV_LED_DDRX |= EV_LED;	//LED liegt an PORTx

EV_TASTER_DDRX &= ~ EV_TASTER;	// Taster Bit  an PINC)
EV_TASTER_PORTX |= EV_TASTER;	// Pullup aktivieren
MAX543_INITDIR();

while(1)  	// endless loop
	{
	// "Hauruck" --verfahren 
	switch( gu8Mode )
		{
		case SQUARE_MODE: //SQUARE:
			{						
			u16Signal = gu8Level; //Rechteck
			_delay_ms(1);
			u16Signal = 0; //Rechteck
			_delay_ms(1);	
			break;
			}
		case SAW_UP_MODE:	//TRIANGLE:
			{
			u16NN %= 220;
			u16Signal = u16NN++;//Sgezahn 
			break;
			}
		case SINE_MODE:	//SINE:
			{
			u16NN++;
			u16NN %= 4096;
			u16Signal = round(2048 + 2047.0 * sin( 2.0 * M_PI * (u16NN / 4096.0)) );  //SINUS
			break;
			}
		case TEST_MODE:	//SINE:
			{
			u16NN++;
			u16NN %= 8;
			u16Signal = (1 << u16NN);
			_delay_ms(200);
			break;
			}	
		default:
			{
			u16Signal = 0;
			break;
			}
		};	
	
	WriteMAX543( u16Signal );
	
	if( EV_TASTER_PINX & EV_TASTER )            //  PINx nicht PORTx
		{
		EV_LED_PORTX &= ~EV_LED;   // lsche wenn 1
		gu8Mode = SINE_MODE;
		}
	else
		{
		EV_LED_PORTX |= EV_LED; // setze wenn 0
		gu8Mode = SAW_UP_MODE; //TEST_MODE;
		};
	};//while

};	//main
// *** MAIN END ***
