
/*
Ausgang
Interrupt an PB5
+ 
Toggle OC1A on Compare Match
(1<<REFS01) --> AVcc = REF, 100nF C an AREDF -_> GND gegen GND
*/

//------------------------------------------------------------------------------
// Programmed by Christof Ermer
//------------------------------------------------------------------------------
#define SOFTWARE	"Frequenz PIU-BOX mit Timer1"
#define HARDWARE	"Arduino-UNO ATMega328"
#define DATUM		"08.01.2015 12:00"
#define AUTOR		"=/\= Christof Ermer =/\= "
#define IHAVENOBRAIN	"I have no brain"	
#define USEYOURS		"Use your own"

#include <avr/sfr_defs.h>
#include <avr\io.h>
#include <util\delay.h>
#include <avr/wdt.h>
#include <avr\interrupt.h>
#include "main.h"
#include "debug.h"


#define LED1_BLINK (1<<PB5)	//LED an BIT 0

// GLOBALE VARIABLEN 
volatile uint32_t gu32_Tick;
volatile uint8_t gu8Status;

// ************************
ISR( TIMER2_OVF_vect)
// ************************
{
volatile static uint32_t u32_Jetzt;
gu32_Tick++;

//Toggle_Bit(2);
if( (gu32_Tick - u32_Jetzt) > 244 )
	{
	u32_Jetzt = gu32_Tick;
	gu8Status |= TICK_EVENT;	
	};	
};

// *************
ISR( TIMER1_COMPA_vect )    // Dieser Vector steht in der iom328p.h
// *************
{ 	// Interrupt Variablen mssen "volatile" deklariert sein

};


//********************************
uint16_t ADC_10Bit(uint8_t u8Chan)
//********************************
/*
Externe 5V REF--Dreaht von AVCC zu 5V+
// PRESCALER 3,6864 / 32 = 115200 50-200Khz gewnscht
*/
{
DDRC &= ~_BV(u8Chan);  //Portx Channel Bit Input  
PORTC &= ~_BV(u8Chan); //Pullup abschalten
//Activate ADC with Prescaler 16 --> 16Mhz/128 = 125 khz
ADMUX = (1<< REFS0) | u8Chan;    //AVCC und AREF mit C an GND
ADCSRA = _BV(ADEN) | _BV(ADPS2) | _BV(ADPS1) |_BV(ADPS0);  
//ADMUX = u8Chan | (1<<REFS0);
ADCSRA |= _BV(ADSC);  //Start conversion 
while( ADCSRA & _BV(ADSC) ) // wait until converstion completed
	{
	//~150S
	wdt_reset();	//WATCHDOG!
	};	   
return ADC;// get converted value
};



// *************
int main(void)
// *************
{
LED_DDRX |= LED1;	     //Bit 0 von PORTC als Ausgang
DDRB |= (1<<PB1);		//OC1A ausgang OCxx

wdt_reset();   //WATCHDOG!
wdt_enable(5); //500mS Totmannknopf

// Timer2 Tick Init
cli();
TCNT2=0;
TIMSK2 |= (1<<TOIE2);
TCCR2B = (1<<CS22) | (1<<CS21);



TCCR1A = (1<<COM1A0);	// Toggle OC1A
TIMSK1 = (1<<OCIE1A); 	// Interrupt aktivieren	16^6/1024=15625
//TCCR1B = (1<<WGM12) | (1<< CS12) | (1<< CS10);//CTC + Vorteiler /1024
//TCCR1B = (1<<WGM12) | (1<< CS12);  			//CTC + Vorteiler /256
//TCCR1B = (1<<WGM12) | (1<< CS11) | (1<< CS10);//CTC + Vorteiler /64
//TCCR1B = (1<<WGM12) | (1<< CS10);				//CTC + Vorteiler /1
OCR1A = 0xFFFF;
TCCR1B = (1<<WGM12) | (1<< CS11);				//CTC + Vorteiler /8
sei(); 
for(;;) 
	{
	wdt_reset();	//WATCHDOG!
	// je hher die Spannung= um so niedriger der TON
	// je niedriger OCR umso Hher der TON
	ADC_10Bit( 0 );  // 16 BIT = 65536
	cli();
	OCR1A = ADC *3;  // Nicht 0 schreiben
	sei();

if( gu8Status & TICK_EVENT )
		{
		Toggle_Bit(1);
		gu8Status &= ~TICK_EVENT;
		LED_PORT ^= LED1;
		};
	};
}; // main
