
#include <avr/sfr_defs.h>
#include <avr\io.h>
#include <util\delay.h>
#include <avr/wdt.h>
#include <avr\interrupt.h>
#include <stdlib.h>
#include <avr\pgmspace.h> // <--#include <progmem.h>
#include "main.h"
#include "debug.h"
#include "OutPort74-595.h"
#include "Knight-Rider2er.h"

uint32_t gu32KRLeds_VAL;
uint16_t gu8KRLedPWM[ USED_LED_CNT ];
//uint8_t gu8KR_Status;

void Init_KnightRider(void)
{
uint8_t u8NN;
uint8_t u8InitVal;

OUT_74595_INITDIRREG();

//TickCounter Starten
//TCCR0B = (1 << CS02) | (1 << CS01);	//Vorteiler //256 einschalten
TCCR0B = (1 << CS00);	//Vorteiler //1 einschalten
TIMSK0 = (1 << TOIE0);	//Interrrupt aktivieren
OCR0A=0;
sei();

for(u8NN=0;u8NN < USED_LED_CNT; u8NN++)
	{
	gu8KRLedPWM[u8NN] = 0;
	};

u8InitVal = 256 /  NACHLAUF_LEDS;

gu8KRLedPWM[0] = 255;
for(u8NN=1;u8NN < NACHLAUF_LEDS; u8NN++)
	{
	gu8KRLedPWM[u8NN] = 256 - u8InitVal;
	u8InitVal *= 2;
	};
};


// ********************
ISR( TIMER0_OVF_vect )    //Dieser Vector steht in der iom328p.h
// ********************
{
uint8_t u8NN;
OCR0A++;
if( !TCNT0 )
	{
	gu32KRLeds_VAL = 0xFFFF;
	};
for(u8NN=0;u8NN < USED_LED_CNT; u8NN++)
	{
	if( gu8KRLedPWM[ u8NN ] == OCR0A) {gu32KRLeds_VAL &= ~( _BV( (OCR0B + u8NN) %  USED_LED_CNT ));};
	};
};


// 