

#ifndef MAIN_HEADER  //Prevents multiple includes
#define MAIN_HEADER

extern volatile uint32_t gu32_Ticks; //  T2 timeCounter, only NN_Counter for Keypressings

#define UART_BAUD_RATE	9600	/* 9600 baud */
//#define UART_BAUD_RATE	19200
//#define UART_BAUD_RATE	57600

#define INFRAROT_RC5_USED

#define ADC_USED_ENABLED


#define TIMER_TICK_USED
#define UART_USE_ENABLED
//#define EEPROM_USED


#define FLOAT_PRAEDIGITS_MAX	6 // DIgits nach //dtostrf(fVal,NUMMAX, DIGITS_MAX, gcaNumStr);
#define FLOAT_DIGITS_MAX		3 // DIgits nach //dtostrf(fVal,NUMMAX, DIGITS_MAX, gcaNumStr);


#define TEXT_SERVICE_USE_ENABLED
#define ENDORDER_CMD_ECHO_ENABLED
#define USE_ERROR_FLAG


#define BIT_0	0x01
#define BIT_1	0x02
#define BIT_2	0x04
#define BIT_3	0x08
#define BIT_4	0x10
#define BIT_5	0x20
#define BIT_6	0x40
#define BIT_7	0x80


#define STRMAX 64
#define NUMMAX 32
#define RX_STRMAX 32
#define COMAMNDSIZEMAX  32

#define DELIMITER		','
#define DELIMITERSTR	","

#define LOW_NIPPEL__MSK		0x0F
#define HIGH_NIPPEL__MSK	0xF0

//TYPEN DEKLARATION
typedef struct
	{
	char ucaCmd[COMAMNDSIZEMAX +1];
	uint8_t ucCmdID;
	float fCmdVal_1;
	float fCmdVal_2;
//char * pcAuxStrucCmdID;
	}COMMAND_TYPE;

// Hardwareassignment
//F_CPU  in makefile !!!

#define PULS_PER_10TEL_SEc		25
#define PULS_PER_SEcONDTick	244
#define PULS_500MS_Tick			122
#define PULS_250MS_TICK			61
#define PULS_100MS_TICK			25
#define PULS_50MS_TICK			13
	

//DELAY
#define TIMEOUT_1_5MS 	1 
#define TIMEOUT_2_9MS 	2
#define TIMEOUT_4_4MS 	3
#define TIMEOUT_10_3MS 	7
#define TIMEOUT_100_7MS	68
#define TIMEOUT_500_7MS	338
#define TIMEOUT_1S 		675		//!!  uint16_t
#define TIMEOUT_5S 		3375	//!!  uint16_t

//REGISTER
#define TCCR0_FAST_PWM	0x48	//Mode 3
#define TCCR0_OC0_MODE	0x20	//Clear ON compare Match
#define TCCR0_OC0_DISCONNECT_MODE	0x00
#define TCCR0_CLK_STOP	0x00	
#define TCCR0_CLK_0		0x01	
#define TCCR0_CLK_8		0x02	
#define TCCR0_CLK_64	0x03	
#define TCCR0_CLK_256	0x04	
#define TCCR0_CLK_1024	0x05	
#define TCCR0_EXT_CLK_FALL_T0	0x06	
#define TCCR0_EXT_CLK_RISE_T0	0x07	

#define TCCR2_WGM_NORMAL		0x00
#define TCCR2_CTC_MODE			0x08 //0000 1000
#define TCCR2_COM_NORMALPORT	0x00
#define TCCR2_CLK_STOP			0x00
#define TCCR2_FASTPWM			0x48	//Mode 3
#define TCCR2_CS_BIST			0x0x	//Mode 3
#define TCCR2_CLK_1024	0x07	
#define TCCR2_CLK_256	0x06	
#define TCCR2_CLK_128	0x05
#define TCCR2_CLK_64	0x04	//
#define TCCR2_CLK_32	0x03
#define TCCR2_CLK_8		0x02	//	1/F = 
#define TCCR2_CLK_0		0x01	
#define TCCR2_CLK_STOP	0x00	
//TIMER2 WIRD BERECHNET /z.B:OverFLow SYSCLK /  256 / TCCR2_CLK_64 =  OVL/Sec

//#define TCCR1B_CLOCKSEL_CTC1 		0x08	//Clear Timer/Counter  on Compare Match Timer/Counter 1
#define TCCR1B_CLOCKSEL_STOP		0x00	//Clock Select Bits
#define TCCR1B_CTC_MODE				0x08	//Clock Select Bits
#define TCCR1B_CLOCKSEL_CPU_1		0x01	//Clock Select Bits
#define TCCR1B_CLOCKSEL_CPU_8		0x02	//Clock Select Bits
#define TCCR1B_CLOCKSEL_CPU_64		0x03	//Clock Select Bits
#define TCCR1B_CLOCKSEL_CPU_256		0x04	//Clock Select Bits
#define TCCR1B_CLOCKSEL_CPU_1024	0x05	//Clock Select Bits

//TIMER
#define TIMSK_TOIE0_FLAG	0x01
#define TIMSK_OCIE0_FLAG	0x02
#define TIMSK_TOIE1_FLAG	0x04
#define TIMSK_OCIE1B_FLAG	0x08
#define TIMSK_OCIE1A_FLAG	0x10
#define TIMSK_TICIE1_FLAG	0x20
#define TIMSK_TOIE2_FLAG	0x40
#define TIMSK_OCIE2_FLAG	0x80

#define TIMSK_T0_CLR_ALL_MASK 0b11111100
#define TIMSK_T1_CLR_ALL_MASK 0b11000011
#define TIMSK_T2_CLR_ALL_MASK 0b00111111

//INTERUPT CTRL REG //NICHT mit MCUCSR verwechseln !
#define MCUCR_LOWLEVEL_INT0		0x00	
#define MCUCR_ANYCHANGE_INT0	0x01 //=_BV(ISC01) 	
#define MCUCR_FALLING_EDGE_INT0	0x02	
#define MCUCR_RISING_EDGE_INT0	0x03
#define MCUCR_INT0_CLEAR_MASK	0xFC

#define MCUCR_LOWLEVEL_INT1		0x00	
#define MCUCR_ANYCHANGE_INT1	0x04 //=_BV(ISC10) 	
#define MCUCR_FALLING_EDGE_INT1	0x08	
#define MCUCR_RISING_EDGE_INT1	0x0C
#define MCUCR_INT1_CLEAR_MASK	0xF3
#define GATE_ANYCHANGE_INT1_MODE()	(MCUCR |= MCUCR_ANYCHANGE_INT1)


//Global Interrrupt CTRL REG
#define GICR_INT0_ON()	(GICR |= _BV(INT0)) //_BV(INT0)
#define GICR_INT0_OFF()	(GICR &= ~(_BV(INT0)))
#define GICR_INT1_ON()	(GICR |= _BV(INT1))
#define GICR_INT1_OFF()	(GICR &= ~(_BV(INT1)))
#define GICR_INT_0u1_OFF()	(GICR &= 0x3F)  //SIEHE DATENBLATT


#define RCO_B_INT_ON()	GICR_INT0_ON() 
#define RCO_B_INT_OFF()	GICR_INT0_OFF()
#define GATE_INT1_ON()	GICR_INT1_ON()
#define GATE_INT1_OFF()	GICR_INT1_OFF()


#define OVERFLOW_CNT_ON_INT0()	RCO_B_INT_ON()
#define OVERFLOW_CNT_OFF_INT0()	RCO_B_INT_OFF()

#define GATE_ALL_EVENT_ON_INT1()	GATE_INT1_ON()
#define GATE_ALL_EVENT_OFF_INT1()	GATE_INT1_OFF()

//GIFR  I_FLAG
#define GIFR_INTF0_SET()	(GIFR |= _BV(INTF0)) //_BV(INT0)
#define GIFR_INTF0_CLR()	(GIFR &= ~(_BV(INTF0)))
#define GIFR_INTF1_CLR()	(GIFR |= _BV(INTF1))
#define GIFR_INTF1_SET()	(GIFR &= ~(_BV(INTF1)))
#define GIFR_INTF_0u1_CLR()	(GIFR &= 0x3F) //Siehe Datenblatt = letzten beiden Bits



//PORTB 
#define MOSI_I         3//BIT3
#define MISO_0         4//BIT4
#define SCK_I          5//BIT5

//#define TCCR1B_CLOCKSEL_CTC1 		0x08	//Clear Timer/Counter  on Compare Match Timer/Counter 1
#define TCCR1B_CLOCKSEL_STOP		0x00	//Clock Select Bits
#define TCCR1B_CLOCKSEL_CPU_1		0x01	//Clock Select Bits
#define TCCR1B_CLOCKSEL_CPU_8		0x02	//Clock Select Bits
#define TCCR1B_CLOCKSEL_CPU_64		0x03	//Clock Select Bits
#define TCCR1B_CLOCKSEL_CPU_256		0x04	//Clock Select Bits
#define TCCR1B_CLOCKSEL_CPU_1024	0x05	//Clock Select Bits



//EEPROM
#define EEPROM_SECTION  __attribute__ ((section (".eeprom")))
#define IEEPROM_SIZE	512	//Interne EEPROM
#define EE_DUMMYLOAD 0x5AA5 //unwahrsch. wert 0101 1010 1010 0101
//If using 8 block by 512 max = 64 Byte/block
//#define IEEPROM_SECTIONSIZE	64   //by 8 Section




//INTERRUPT
#define INTx_INPORT	PIND
//#define INT1__MSK	0x08  //PD3
//#define INT0__MSK	0x04  //PD2
#define INT0_PIN_NR	PD2
#define INT1_PIN_NR	PD3

//PORTB
#define TWI_DIRREG		DDRC
#define TWI_OUT_PORT	PORTC
#define TWI_IN_PORT		PINC
#define TWI_SDA			PC4		//PC4	OUT
#define TWI_SCL			PC5		//PC5	IN


//WERT IN ADCW
#define I2C_CLOCK_BIT	PC0
#define I2C_DATA_BIT	PC1

/*
#define Clr_TWI_SDA()	 	TWI_OUT_PORT &= ~PC_SDA_BIT;	 
#define Set_TWI_SDA()	 	TWI_OUT_PORT |= PC_SDA_BIT;	 
#define TWI_SCL_IS_HIGH		(TWI_IN_PORT & PC_SCL_BIT )
#define TWI_SCL_IS_LOW		(!(TWI_IN_PORT & PC_SCL_BIT))
*/

//PORTD TX/RX ERST MAL FR  FLAGS
#define PD0_RX_BIT	0x01	//PIN2
#define PD1_TX_BIT	0x02	//PIN3


//========================================================================

//TIMERS
//TIMER2  = is 61 miliseconds Timer ~approx.
// 16MhZ / 1024 / 256  = 61,03515625 Hz
// T= 1/f = 0.016384 ms / Interrupt
//PORT_ASSIGMNEMTS
#define WDTO_2S   7 //WatchDog
//SOFTWARE USED DEFINES

#define ASC_CR	13
#define ASC_DELIMITER	','

//TIMER
#define TI_MSK_TOIE0_FLAG	0x01
#define TI_MSK_OCIE0_FLAG	0x02
#define TI_MSK_TOIE1_FLAG	0x04
#define TI_MSK_OCIE1B_FLAG	0x08
#define TI_MSK_OCIE1A_FLAG	0x10
#define TI_MSK_TICIE1_FLAG	0x20
#define TI_MSK_TOIE2_FLAG	0x40	//#define TOIE2 6     (1 << TOIE2)
#define TI_MSK_OCIE2_FLAG	0x80

#define TI_MSK_T0_CLR_ALL__MSK 0b11111100
#define TI_MSK_T1_CLR_ALL__MSK 0b11000011
#define TI_MSK_T2_CLR_ALL__MSK 0b00111111


#define TIFR_TOV0_TIMER_OVERFLOW_FLAG	0x01
#define TIFR_OCF0_OUT_PCOMPARE_FLAG		0x02
#define TIFR_TOV1_TIMER_OVERFLOW_FLAG	0x04
#define TIFR_OCF1A_OUTP_COMPARE_A_FLAG	0x10
#define TIFR_OCF1B_OUTP_COMPARE_B_FLAG	0x08
#define TIFR_TOV2_TIMER_OVERFLOW_FLAG	0x40
#define TIFR_OCF2_OUTP_COMPARE_FLAG		0x80

//INTERRUPT MODE
//#define MCUCR_INT0_LOWLEVEL_CLR_MSK	0xFC
#define MCUCR_INT0_LOWLEVEL		0x00
#define MCUCR_INT0_ANY_CHANGE	0x01
#define MCUCR_INT0_FALLING_EDGE	0x02
#define MCUCR_INT0_RISING_EDGE	0x03
#define MCUCR_INT0_CLEAR__MSK	0xFC

//#define MCUCR_INT1_LOWLEVEL_CLR_MSK	0xF3
#define MCUCR_INT1_LOWLEVEL		0x00
#define MCUCR_INT1_ANY_CHANGE	0x04
#define MCUCR_INT1_FALLING_EDGE	0x08	//_BV(ISC11)
#define MCUCR_INT1_RISING_EDGE	0x0C
#define MCUCR_INT1_CLEAR__MSK	0xF3
 

#define GICR_INT1_FLAG	0x80
#define GICR_INT0_FLAG	0x40
#define GICR_INT2_FLAG	0x20

#define GIFR_INTF1_FLAG	0x80
#define GIFR_INTF0_FLAG	0x40
#define GIFR_INTF2_FLAG	0x20

//TIMERS
#define TCCR0_FAST_PWM	0x48	//Mode 3
#define TCCR0_OC0_MODE	0x20	//Clear ON compare Match
#define TCCR0_OC0_DISCONNECT_MODE	0x00
#define TCCR0_CLK_1024	0x05	//~61,035 PWM
#define TCCR0_CLK_256	0x04	//244,14Hz PWM
#define TCCR0_CLK_64	0x03	//976,56Hz PWM
#define TCCR0_CLK_8		0x02	//7812 Hz PWM
#define TCCR0_CLK_0		0x01	//62500 PWM
#define TCCR0_CLK_STOP__MSK	0xF8	

#define TCCR2_WGM_NORMAL	0x00
#define TCCR2_CTC_MODE		0x08 //0000 1000
#define TCCR2_COM_NORMALPORT	0x00
#define TCCR2_FASTPWM		0x48	//Mode 3
#define TCCR2_CS_BIST		0x0x	//Mode 3
#define TCCR2_CLK_0			0x01
#define TCCR2_CLK_8			0x02
#define TCCR2_CLK_32		0x03
#define TCCR2_CLK_64		0x04
#define TCCR2_CLK_128		0x05
#define TCCR2_CLK_256		0x06
#define TCCR2_CLK_1024		0x07
#define TCCR2_CLK_STOP__MSK	0xF8

//TCCR1A

#define TCCR1A_CTC_MODE			0x00	//WGM11 WGM10  = 0
#define TCCR1A_FAST_PWM_ICR1	0x02 //WGM11
#define TCCR1A_FAST_PWM_OCR1A	0x03 //WGM11 WGM10 

//#define TCCR1B_CLOCKSEL_CTC1 		0x08	//Clear Timer/Counter  on Compare Match Timer/Counter 1
#define TCCR1B_CLOCKSEL_STOP		0x00	//Clock Select Bits
#define TCCR1B_CTC_MODE				0x08	//Clock Select Bits
#define TCCR1B_CLOCKSEL_CPU_1		0x01	//Clock Select Bits
#define TCCR1B_CLOCKSEL_CPU_8		0x02	//Clock Select Bits
#define TCCR1B_CLOCKSEL_CPU_64		0x03	//Clock Select Bits
#define TCCR1B_CLOCKSEL_CPU_256		0x04	//Clock Select Bits
#define TCCR1B_CLOCKSEL_CPU_1024	0x05	//Clock Select Bits
#define TCCR1B_CLK_STOP__MSK		0xF8

#define TC1_USED_CLOCKS_PER_SEC		15625	//16^6 / 1024


//ADC //AT16
#define ADMUX_MUX0	0
#define ADMUX_MUX1	1
#define ADMUX_MUX2	2
#define ADMUX_MUX3	3
#define ADMUX_MUX4	4
#define ADMUX_MUX5	5
#define ADMUX_MUX6	6
#define ADMUX_MUX7	7
#define ADMUX_MUX_1_23V	0xE0
#define ADMUX_MUX_GND	0xF0

#define ADMUX_DIFF_ADC0_GAIN10	0x10
#define ADMUX_DIFF_ADC1_GAIN10	0x11
#define ADMUX_DIFF_ADC0_GAIN200	0x12
#define ADMUX_DIFF_ADC1_GAIN200	0x13
//usw.
#define ADMUX_ADLAR	0x20
#define ADMUX_REFS0	0x40
#define ADMUX_REFS1	0x80
#define ADC_MUX_MASK	0x0F

//PRESCALER
#define ADCSRA_ADPS0	0x01
#define ADCSRA_ADPS1	0x02
#define ADCSRA_ADPS2	0x04
#define ADCSRA_ADIE		0x08
#define ADCSRA_ADIF		0x10		//INTERRRUPT FLAG
#define ADCSRA_ADFR		0x20	//FREE RUNNNG SEL
#define ADCSRA_ADSC		0x40	//START  //while (ADCSRA & _BV(ADSC) ) 
#define ADCSRA_ADEN		0x80	//Enable

#define  ADCSRA_PRESCALER_2		0x01
#define  ADCSRA_PRESCALER_4		0x02
#define  ADCSRA_PRESCALER_8		0x03
#define  ADCSRA_PRESCALER_16	0x04
#define  ADCSRA_PRESCALER_32	0x05
#define  ADCSRA_PRESCALER_64	0x06
#define  ADCSRA_PRESCALER_128	0x07
//WERT IN ADCW




// **************** HARDWARE *********************************
//AT16 BOARD V3.3  Halbe Eurokarte 100x80
// **************** HARDWARE *********************************



#define POTI_RANGE_LIMIT	1000U
#define POTI_ZERO_OFFSET	11 //Ab diesem Wert wird Wert als 0 definiert
#define POTI_UPPER_LIMIT	1012 // ADCRESOLUTION - POTI_ZERO_OFFSET


// ------- anderes Zeug -------------------------

//CHECK PUD = PULLUPDISSABLE in SFIOR 
#define DISABLE_ALL_PULLUP()	(SFIOR |= _BV(PUD));
#define ENABLE_ALLUP_SCL()	(SFIOR &= ~(_BV(PUD)));
// 1.main.c einstellungen
//PORTA //1=OUT
#define PORTA_DDRX_OUT_MSK		0X00
#define PORTA_PRESET_PULL_MSK	0x00	//Ohne Pullup

//CHECK PUD = PULLUPDISSABLE in SFIOR 
//PORT B //1=OUT
#define PORTB_DDRX_OUT_MSK		0X00			
#define PORTB_PRESET_PULL_MSK	0X00	//Ohne Pullup	

//PORT C //STARTWERTE
#define PORTC_DDRX_OUT_MSK		0x00
#define PORTC_PRESET_PULL_MSK	0X00	//Ohne Pullup

//PORT D //da ist TX/RX & zusatzhardware
#define PORTD_DDRX_OUT_MSK		0b00000010
#define PORTD_PRESET_PULL_MSK	0b00000000	//Ohne Pullup

//Ablaufgorganisation
#define STATE_FLAG_LINKSRUM	0x01
//#define STATE_FLAG_SINGLE_LED	0x08

//#define RX_BIT		PD0	//0
//#define TX_BIT		PD1	//1


#endif  //MAIN_HEADER

