
//------------------------------------------------------------------------------
// Programmed by Christof Ermer
//------------------------------------------------------------------------------
#define SOFTWARE	"TICK_TIMER_TASTE INT0"
#define HARDWARE	"Arduino-UNO ATMega328"
#define DATUM		"16.03.2017 12:00"
#define AUTOR		"=/\= Christof Ermer =/\= "
#define IHAVENOBRAIN	"I have no brain"	
#define USEYOURS		"Use your own"

#include <avr/sfr_defs.h>
#include <avr\io.h>
#include <util\delay.h>
//#include <math.h>
#include <avr\interrupt.h>
#include <math.h>

#define LED1	0x01

#define TICK_EVENT	0x01

volatile uint32_t gu32_Tick;
volatile uint8_t gu8Status;

// ************************
ISR( TIMER2_OVF_vect)
// ************************
{
volatile static uint32_t u32_Jetzt;

gu32_Tick++;

if( (gu32_Tick - u32_Jetzt) > 244 )
	{
	u32_Jetzt = gu32_Tick;
	gu8Status |= TICK_EVENT;	
	};	
};

#define SOLLFREQUENZ 1000

// ************************
int main (void)
// ************************
{
uint16_t u16NN=100;
uint32_t u32FrqStep;
DDRC |= LED1;		//Bit auf Ausgang setzen;

// Timer2 Tick Init
cli();
TCNT2=0;
TIMSK2 |= (1<<TOIE2);
TCCR2B = (1<<CS22) | (1<<CS21);

//Timer1 Syntheziser
TCNT1 = 0;
DDRB |= (1<< PORTB1 );	// OUPUT OC1A
TCCR1A = (1<< COM1A0 );  // TOGGLE OC1A
//OCR1A = 16000000UL / 1024 / SOLLFREQUENZ;
OCR1A = F_CPU / 8 / (SOLLFREQUENZ * 2);

TCCR1B = (1<< WGM12 ) | (1<< CS11 ) ; // 8 CTC

sei();

while (1)
	{
	
	if( (gu32_Tick - u32FrqStep) > 5 )
		{
		u32FrqStep = gu32_Tick;
		
		u16NN++;
		u16NN %= 300;
		
		OCR1A = 1000 + 300 * sin( 2* M_PI * (u16NN/300.0));
		TCNT1 = 0;
			
		};	
	
	if( gu8Status & TICK_EVENT )
		{
		gu8Status &= ~TICK_EVENT;
		PORTC ^= LED1;
		}	
	};
};