

/*
60-AT328-UM-74-595 Output
UART & Mnemonic
*/

//------------------------------------------------------------------------------
// Programmed by Christof Ermer
//------------------------------------------------------------------------------

#define SOFTWARE	"UART Mnenomic Module"
#define HARDWARE	"Arduino-UNO ATMega328"
#define DATUM		"02.02.2015 12:00"
#define AUTOR		"* Christof Ermer *"
#define IHAVENOBRAIN	"I have no brain"	
#define USEYOURS		"Use your own"

#include <avr/sfr_defs.h>
#include <avr\io.h>
#include <util\delay.h>
#include <avr/wdt.h>
#include <avr\interrupt.h>
#include <stdlib.h>
#include <avr\pgmspace.h> // <--#include <progmem.h>
#include "main.h"
#include "uartATM328.h"
#include "Befehle.h"
#include "max7219.h"
#include "debug.h"


// GLOBALE VARIABLEN 
volatile uint32_t gu32_Ticks;	 //  T2 TimerCounter
volatile uint8_t gu8Status;

// Interrupt Section
// ********************
ISR( TIMER2_OVF_vect )    //Dieser Vector steht in der iom328p.h
// ********************
{ 	// Interrupt Variablen mssen "volatile" deklariert sein
volatile static uint32_t u32MerkeT;
Toggle_Bit(1);

//hochzhlen ? 244*/Sekunde
if( ( (gu32_Ticks++) - u32MerkeT) > TICK_500MS )
	{
	u32MerkeT = gu32_Ticks;	//neue Zeit merken
	gu8Status |= STATUS_TICK_EVENT;
	};
// !! 244*/ Sekunde	
UART_TXRX_Check();  //langsam, aber sehen ob was kommt am UART
};


// *************
int main(void)
// *************
{

uint8_t u8Val;
uint8_t u8NN = 0;

DDRB |= LED1_BLINK;	     //Bit 0 von PORTC als Ausgang

wdt_reset();   //WATCHDOG!
wdt_enable(5); //500mS Totmannknopf

uart_init( UART_BAUD_SELECT_DOUBLE_SPEED(UART_BAUD_RATE, F_CPU) );
sei(); 
ResetRxBuff();

//TickCounter Starten
TCCR2B = (1 << CS22) | (1 << CS21);	//Vorteiler //256 einschalten
TIMSK2 = (1 << TOIE2);	//Interrrupt aktivieren

sei();
uart_puts_p( PSTR( HARDWARE ));uart_putc(13); 
uart_puts_p(  PSTR( SOFTWARE ) );uart_putc(13);
uart_puts_p( PSTR( DATUM )  );uart_putc(13); 
uart_puts_p( PSTR( AUTOR ) );uart_putc(13); 
uart_puts_p( PSTR( IHAVENOBRAIN ) );uart_putc(13); 
uart_puts_p( PSTR( USEYOURS ) );uart_putc(13); 

MAX7219_Init();
MAX7219_Clear();
for(;;) 
	{
	sei();
	wdt_reset();	//WATCHDOG!
	if( gu8Status & STATUS_TICK_EVENT )
		{		
		gu8Status &= ~STATUS_TICK_EVENT;
		
		///u8Val = (uint8_t)(1 << (gu32_Ticks % 8));
		u8Val= ( 1 << (u8NN % 8) );
		u8NN++;
		MAX7219_Clear();
		MAX7219_Write(1, u8Val);

		PORTB ^= LED1_BLINK;	// ab jetzt langsame ~1Hz Action
		if( gu8Status & STATUS_TRIGGER_OUTPUT )
			{
			uart_puts_p( PSTR("Tick=") );
			uart_puts( ultoa( gu32_Ticks, gcaStr, 10 ) );
			uart_putc( 13 ); //CR			
			};
		};
//Toggle_Bit(1);
	};
}; // main
