
//------------------------------------------------------------------------------
// Programmed by Christof Ermer
//------------------------------------------------------------------------------
#define SOFTWARE	"PROGMEM"
#define HARDWARE	"Arduino-UNO ATMega328"
#define DATUM		"30.03.2016 12:00"
#define AUTOR		"=/\= Christof Ermer =/\= "
#define IHAVENOBRAIN	"I have no brain"	
#define USEYOURS		"Use your own"

#include <avr/sfr_defs.h>
#include <avr\io.h>
#include <util\delay.h>
#include <math.h>
#include <avr/pgmspace.h>

#include "main.h"
#include "MAX543.h"
#include "LEDLeiste.h"

#define SINE_MODE 		0x01
#define SAW_UP_MODE		0x02
#define TRIANGLE_MODE	0x04
#define SQUARE_MODE		0x08
#define TEST_MODE		0x10
#define PROGMEM_MODE	0x20
#define RAM_SINE_MODE	0x40

uint8_t gcaWave[256];

const char MCA_SINUS[] PROGMEM = {        // "256 Byte SINUS von 0..255
128,131,134,137,140,143,146,149,152,155,158,162,165,167,170,173,176,179,182,\
185,188,190,193,196,198,201,203,206,208,211,213,215,218,220,222,224,226,228,\
230,232,234,235,237,238,240,241,243,244,245,246,248,249,250,250,251,252,253,\
253,254,254,254,255,255,255,255,255,255,255,254,254,254,253,253,252,251,250,\
250,249,248,246,245,244,243,241,240,238,237,235,234,232,230,228,226,224,222,\
220,218,215,213,211,208,206,203,201,198,196,193,190,188,185,182,179,176,173,\
170,167,165,162,158,155,152,149,146,143,140,137,134,131,128,124,121,118,115,\
112,109,106,103,100,97,93,90,88,85,82,79,76,73,70,67,65,62,59,57,54,52,49,47,\
44,42,40,37,35,33,31,29,27,25,23,21,20,18,17,15,14,12,11,10,9,7,6,5,5,4,3,2,\
2,1,1,1,0,0,0,0,0,0,0,1,1,1,2,2,3,4,5,5,6,7,9,10,11,12,14,15,17,18,20,21,23,\
25,27,29,31,33,35,37,40,42,44,47,49,52,54,57,59,62,65,67,70,73,76,79,82,85,88,\
90,93,97,100,103,106,109,112,115,118,121,124};

// Anwendung:   u8Val = pgm_read_byte_near(MCA_SINUS + u8NN++);

void FillWave(void)
{
uint16_t u16NN;
for(u16NN=0; u16NN <256; u16NN++)
	{
	gcaWave[u16NN]= round(128 + 127.0 * sin( 2.0 * M_PI * (u16NN / 256.0)) );  //SINUS
	};
};


uint8_t gu8Mode = SINE_MODE;
uint8_t	gu8Level = 127;
// *******************
int main(void)
// *******************
{
uint8_t u8NN=0;
uint16_t u16NN=0;
uint16_t u16Signal;
EV_LED_DDRX |= EV_LED;	//LED liegt an PORTx

EV_TASTER_DDRX &= ~ EV_TASTER;	// Taster Bit  an PINC)
EV_TASTER_PORTX |= EV_TASTER;	// Pullup aktivieren
MAX543_INITDIR();

FillWave();

while(1)  	// endless loop
	{
	// "Hauruck" --verfahren 
	switch( gu8Mode )
		{
		case SQUARE_MODE: //SQUARE:
			{						
			u16Signal = gu8Level; //Rechteck
			_delay_ms(1);
			u16Signal = 0; //Rechteck
			_delay_ms(1);	
			break;
			}
		case SAW_UP_MODE:	//TRIANGLE:
			{
			u16NN %= 220;
			u16Signal = u16NN++;//Sgezahn 
			break;
			}
		case SINE_MODE:	//SINE:
			{
			u8NN++;
			//u16NN %= 4096;
			u16Signal = round(2048 + 2047.0 * sin( 2.0 * M_PI * (u8NN / 256.0)) );  //SINUS
			break;
			}
		case PROGMEM_MODE:	//SINE:
			{	
			//u8NN++;		
			u16Signal = 16* pgm_read_byte_near( MCA_SINUS + u8NN++);		
			break;
			}	
		case RAM_SINE_MODE:	//SINE:
			{	
			u16Signal = 16* gcaWave[u8NN++];
			break;
			}	
		case TEST_MODE:	//SINE:
			{
			u16NN++;
			u16NN %= 8;
			u16Signal = (1 << u16NN);
			_delay_ms(200);
			break;
			}	
		default:
			{
			u16Signal = 0;
			break;
			}
		};	
	
	WriteMAX543( u16Signal );
	
	if( EV_TASTER_PINX & EV_TASTER )            //  PINx nicht PORTx
		{
		EV_LED_PORTX &= ~EV_LED;   // lsche wenn 1
		gu8Mode = RAM_SINE_MODE;
		}
	else
		{
		EV_LED_PORTX |= EV_LED; // setze wenn 0
		gu8Mode = PROGMEM_MODE;// SAW_UP_MODE; //TEST_MODE;
		};
	};//while

};	//main
// *** MAIN END ***
