
#include <ctype.h>
#include <avr\io.h>
#include <inttypes.h>

#include "i2cmaster.h"
#include "ds1337.h"
#include "debug.h"
/*
2 programmable Time of Day Alarms
programmable square-wave output Defaults to 32kHz on Power-Up.
Address and data are transferred serially through an I2C bus.
clock/calendar provides seconds, minutes, hours, day, date, month, and year information.
24-hour or 12-hour format with AM/PM indicator.
VCC is between 1.8V and 5.5V.
Oscillator Stop Flag
*/

RTCTime_t gstRTCTime;
RTCAlarm_1_Time_t gstRTCAlarm_1_Time;
RTCAlarm_2_Time_t gstRTCAlarm_2_Time;
uint8_t gu8DS1337_Ctrl;
uint8_t gu8DS1337_Status;

short RTC_DS1337_Init(void)
{
gstRTCTime.u8Day = RTC_DAY_DEFAULT;
gstRTCTime.u8Month = RTC_MONTH_DEFAULT;
gstRTCTime.u8Year = RTC_YEAR_DEFAULT;

//Da kom ich schon nict merh hin
//Toggle_Bit(5);
//ret = i2c_start( 0b01101000 + I2C_READ ); // <<1
if( i2c_start( DS1337_ADR + I2C_READ ) ) // 1= wrong
	{
	// failed to issue start condition, possibly no device found
	i2c_stop();
	return -1;
	};
i2c_stop();
return 0;
};		


int bcd(int dec)
{
return ((dec/10)<<4)+(dec%10);
}


int decimal(int bcd)
{
return ((bcd>>4)*10)+bcd%16;
}



void DS1337_Read_Full( void )
{

//i2c_start( DS1337_ADR + I2C_READ) ;
i2c_start_wait( DS1337_ADR + I2C_READ) ;

gstRTCTime.u8Second = decimal( i2c_readAck() & 0x7F);
gstRTCTime.u8Minutes = decimal( i2c_readAck() & 0x7F);
gstRTCTime.u8Hour = decimal( i2c_readAck() & 0x1F);
gstRTCTime.u8Day = i2c_readAck() & 0x07;
gstRTCTime.u8Date = decimal( i2c_readAck() & 0x3F );
gstRTCTime.u8Month = decimal( i2c_readAck() & 0x1F);
gstRTCTime.u8Year = decimal(i2c_readAck() );

gstRTCAlarm_1_Time.u8Second = decimal( i2c_readAck() & 0x7F);
gstRTCAlarm_1_Time.u8Minutes = decimal( i2c_readAck() & 0x7F);
gstRTCAlarm_1_Time.u8Hour = decimal( i2c_readAck() & 0x1F);
gstRTCAlarm_1_Time. u8DayDate = decimal( i2c_readAck() & 0x3F);

gstRTCAlarm_2_Time.u8Minutes = decimal( i2c_readAck() & 0x7F);
gstRTCAlarm_2_Time.u8Hour = decimal( i2c_readAck() & 0x1F);
gstRTCAlarm_2_Time. u8DayDate = decimal( i2c_readAck() & 0x3F);
gu8DS1337_Ctrl = i2c_readAck();
gu8DS1337_Status = i2c_readNak();

i2c_stop();

/*
gstRTCTime.u8Hour;
gstRTCTime.u8Minutes;
gstRTCTime.u8Day;
gstRTCTime.u8Month;
gstRTCTime.u8Year;
*/
};