

/*
http://www.atmel.com/dyn/products/app_notes.asp?family_id=607
http://www.rn-wissen.de/index.php/Regelungstechnik#Digitaler_Regler
http://meinews.niuz.biz/pid-t290130.html?s=0e1ded0ef83615ae0f18eff7a1dd40be&amp;
http://www.mikrocontroller.net/topic/57656
*/

/* PID
esum = esum + e
y = Kp * e + Ki * Ta * esum + Kd * (e  ealt)/Ta
ealt = e
*/


/*
Der nachfolgende Code wird im Rhythmus der Abtastzeit Ta immer wieder aufgerufen.
// w= soll
// x= Sensor
// e = w - x

// code
e = w - x;									//Vergleich
esum = esum + e;							//Integration I-Anteil
y = Kp*e + Ki*Ta*esum + Kd/Ta*(e  ealt);	//Reglergleichung
ealt = e;
*/


/*
Alternative Umsetzung in Code nach dem Stellungsalgorithmus:
y entspricht yk, yalt entspricht yk-1, e entspricht ek, ealt entspricht ek-1, ealt2 entspricht ek-2
e = w - x;					//Vergleich
y = yalt + q0*e + q1*ealt + q2*ealt2;		//Reglergleichung
ealt2 = ealt;
ealt = e;
yalt = y;
*/

// ***** GLOBAL *****
static float fesum;
static float fealt;



float PID_Calcualte(float fTa, float fKp, float fKi,  float fKd, float fw, float fx,)
{
float fy, fe;
//Der nachfolgende Code wird im Rhythmus der Abtastzeit Ta immer wieder aufgerufen.
// w= soll
// x= Sensor
// e = w - x

// code
fe = fw - fx;				//Vergleich
fesum = fesum + fe;		//Integ
fy = fKp*fe + fKi*fTa*fesum + fKd / fTa*(fe  fealt);	//Reglergleichung
fealt = fe;
return fy;
};

