#ifndef _DS1302_H
#define _DS1302_H


#include <avr/io.h>
#include <delay.h>


/*connection settings*/
#define RTC_RST		5
#define RTC_CLK		3
#define RTC_IO		4
#define RTC_DDR		DDRC
#define RTC_PORT	PORTC
#define	RTC_PIN		PINC


/*command settings*/
#define SEC				0
#define MIN				1
#define HR				2
#define DATE			3
#define MONTH			4
#define DAY				5
#define YEAR			6
#define CONTROL			7
#define TRICKLECHARGE	8
#define CLOCKBURST		31

/*RAM may be used, if neccessary*/
/*	#define RAM0		32
	#define RAM1		33
	#define RAM2		34
	...
	...
	...
	#define RAM30		62
	#define RAMBURST	63
*/

/*write byte in specified register*/
void ds1302_write(unsigned char command);

/*read byte out of specified register*/
unsigned char ds1302_read(void);

/*low-level-routine which writes byte*/
void write_byte(unsigned char,unsigned char);

/*low-level-routine which reads byte*/
unsigned char read_byte(unsigned char);

#endif

