

//------------------------------------------------------------------------------
// Programmed by Christof Ermer
//------------------------------------------------------------------------------

//SYSINFO
#define DATUM		"21.03.2011"
#define FUNKTION	"ALoa Welle"
#define HARDWARE	"Atmel ATTiny13A"
#define UHRZEIT	"12:00"
#define AUTOR		"Christof Ermer"

#define IHAVENOBRAIN	"I have no brain."	
#define USEYOURS		"Use your own"

/*  HISTORY 
In Interupts...alle Vars deklarieren mit 
volatile uint32_t Tickscounter..
*/

#include <avr\io.h>
//#include <ctype.h>
#include <inttypes.h>
//#include <avr\pgmspace.h> // <--#include <progmem.h>

//#include <stdio.h>
//#include <math.h>
#include <stdlib.h>
#include <stdarg.h>
//#include <string.h>
#include <avr\interrupt.h>  // obsolete #include <avr\signal.h>

//ACHTUNG STELLT OBSOLETE Procedure in header wieder her
//#include <compat\deprecated.h>
#include <util\delay.h>	//_delay_loop_1 _delay_loop_2 delay_ms
//#include <avr\wdt.h>

#include "main.h"		//with Hardware assigns


#ifdef TIMER_TICK_USED
void StartTickTimer(void);	//0.1 Seconds  interrupt
#endif

#ifdef TIMER_TICK_USED
volatile uint32_t gu32_Ticks; //T2 timeCounter, only NN_Counter for Keypressings
#endif
volatile uint16_t gu16_LDRLevel;
volatile uint16_t gu16_ADCVal;

#ifdef ADC_USED_ENABLED
uint16_t LDR_ADC_10Bit(void);
#endif

#ifdef TIMER_TICK_USED 
// ****************************************************************
//volatile  SIGNAL(TIMER2_OVF_vect) //oder SIGNAL--INTERRUPT(SIG_OVERFLOW2) = mit SEI am Anfang
SIGNAL( TIM0_OVF_vect ) //ISR oder SIGNAL
// *******************************************************************
{
sei();
gu32_Ticks++;
};
#endif


#ifdef ADC_USED_ENABLED //INTERNREF 2.5V
// ****************************
uint16_t LDR_ADC_10Bit( void )
// ****************************
{
ADCSRA = ADCSRA_ADEN | ADCSRA_PRESCALER_8;   //ADC EIN UND PreScaler
//UREF = VCC	PB3 = LDR
ADMUX = ADMUX_ADC3;	// ADMUX_REFS0 Select pin ADCx using MUX  
ADCSRA |= ADCSRA_ADSC;	//ADCSRA |= _BV(ADSC);	//Start conversion
while( ADCSRA & ADCSRA_ADSC )	//wait until _BV(ADSC)=0 =converstion completed
	{
	};	
return ADC;
};
#endif

/*
// ***************************
void ReactionTimeMS( uint16_t u16Time )
// ***************************
{
for(uint16_t u16NN=0; u16NN <u16Time; u16NN++)
	{
	_delay_ms(1);
	//wdt_reset();
	};
};
*/

// *******************************************************************
int main(void)
// *******************************************************************
{
uint32_t u32Now;
uint32_t u32LED_on_Time;

//SFIOR = (1<<PUD); //Pullup Disable
//wdt_enable(WDTO_2S); //Set 1.9Sec WatchDog ENABLE
//wdt_reset();

DDRB = PORTB_DDRX_OUT_MSK;
u32Now = 0;
gu32_Ticks = 0;	

gu16_LDRLevel = LDR_ADC_10Bit() + 1;

TIMSK0 = TIMSK0_TOIE0_FLAG;
TCCR0B = TCCR0B_CLK_64;

//#define RAND_MAX   0x7FFF #define RANDOM_MAX   0x7FFFFFFF random();
//srand( rand() ); // seed random
// ************ MAIN LOOP *********************
for(;;)  /* loop forever */ //Aber schnell > 200.000 mal/Sekunde
// ************ MAIN LOOP *********************
	{	
	sei();
 	//wdt_reset();	//WATCHDOG!
	gu16_ADCVal = LDR_ADC_10Bit();	
	if ( gu16_ADCVal > gu16_LDRLevel )
		{
		if( TCNT0 > 127 )
			{			
			_delay_ms(200);//ReactionTimeMS(200);
			SET_LED();
   		u32LED_on_Time = gu32_Ticks;
         gu16_LDRLevel = gu16_ADCVal + 1;
			}
		};

#ifdef TIMER_TICK_USED
	if( (gu32_Ticks - u32Now) > TICKS_1SEC) //Hier kann was gemacht werden jede 1/10 Sekunde
		{
		
      if( !(rand() % 1000) ) // Zudalls On
         {
         SET_LED();
         };
         
      u32Now = gu32_Ticks; //Zeit merken !!		
		if( IS_LED_ON() && ((gu32_Ticks - u32LED_on_Time) > TICKS_2SEC ) )
			{
			CLR_LED();
			};
         
      if( IS_LED_OFF() )   
         {         
         gu16_LDRLevel = gu16_ADCVal +1 ;
         };
		};
#endif
	}; //main loop Ende
};
// ******************* MAIN END ********************************************
