

#ifndef MAIN_HEADER  //Prevents multiple includes
#define MAIN_HEADER

#define TIMER_TICK_USED
#define ADC_USED_ENABLED

#define FLOAT_PRAEDIGITS_MAX	6 // DIgits nach //dtostrf(fVal,NUMMAX, DIGITS_MAX, gcaNumStr);
#define FLOAT_DIGITS_MAX		3 // DIgits nach //dtostrf(fVal,NUMMAX, DIGITS_MAX, gcaNumStr);

#define BIT_0	0x01
#define BIT_1	0x02
#define BIT_2	0x04
#define BIT_3	0x08
#define BIT_4	0x10
#define BIT_5	0x20
#define BIT_6	0x40
#define BIT_7	0x80

#define LOW_NIPPEL__MSK		0x0F
#define HIGH_NIPPEL__MSK	0xF0

// Hardwareassignment
//F_CPU  in makefile !!!

//TIMER
#define TCCR0B_CLK_STOP	0x00	
#define TCCR0B_CLK_0		0x01	
#define TCCR0B_CLK_8		0x02	
#define TCCR0B_CLK_64	0x03	
#define TCCR0B_CLK_256	0x04	
#define TCCR0B_CLK_1024	0x05	

#define TIMSK0_TOIE0_FLAG	0x02
#define TIMSK0_OCIE0A_FLAG	0x04
#define TIMSK0_OCIE0B_FLAG	0x08

#define TIFR0_TOV0_FLAG		0x02
#define TIFR0_OCF0A_FLAG	0x04
#define TIFR0_OCF0B_FLAG	0x08

//Global Interrrupt CTRL REG
#define GICR_INT0_ON()	(GICR |= _BV(INT0)) //_BV(INT0)
#define GICR_INT0_OFF()	(GICR &= ~(_BV(INT0)))
#define GICR_INT1_ON()	(GICR |= _BV(INT1))
#define GICR_INT1_OFF()	(GICR &= ~(_BV(INT1)))
#define GICR_INT_0u1_OFF()	(GICR &= 0x3F)  //SIEHE DATENBLATT

#define RCO_B_INT_ON()	GICR_INT0_ON() 
#define RCO_B_INT_OFF()	GICR_INT0_OFF()
#define GATE_INT1_ON()	GICR_INT1_ON()
#define GATE_INT1_OFF()	GICR_INT1_OFF()

#define OVERFLOW_CNT_ON_INT0()	RCO_B_INT_ON()
#define OVERFLOW_CNT_OFF_INT0()	RCO_B_INT_OFF()

#define GATE_ALL_EVENT_ON_INT1()	GATE_INT1_ON()
#define GATE_ALL_EVENT_OFF_INT1()	GATE_INT1_OFF()

//PORTB 
#define MOSI_I         3//BIT3
#define MISO_0         4//BIT4
#define SCK_I          5//BIT5

//EEPROM
#define EEPROM_SECTION  __attribute__ ((section (".eeprom")))
#define IEEPROM_SIZE	512	//Interne EEPROM
#define EE_DUMMYLOAD 0x5AA5 //unwahrsch. wert 0101 1010 1010 0101
//If using 8 block by 512 max = 64 Byte/block
//#define IEEPROM_SECTIONSIZE	64   //by 8 Section

#define WDTO_2S   7 //WatchDog

#define ADCSRA_ADPS0	0x01
#define ADCSRA_ADPS1	0x02
#define ADCSRA_ADPS2	0x04
#define ADCSRA_ADIE		0x08
#define ADCSRA_ADIF		0x10		//INTERRRUPT FLAG
#define ADCSRA_ADFR		0x20	//FREE RUNNNG SEL
#define ADCSRA_ADSC		0x40	//START  //while (ADCSRA & _BV(ADSC) ) 
#define ADCSRA_ADEN		0x80	//Enable

//PRESCALER
#define  ADCSRA_PRESCALER_2		0x01
#define  ADCSRA_PRESCALER_4		0x02
#define  ADCSRA_PRESCALER_8		0x03
#define  ADCSRA_PRESCALER_16	0x04
#define  ADCSRA_PRESCALER_32	0x05
#define  ADCSRA_PRESCALER_64	0x06
#define  ADCSRA_PRESCALER_128	0x07

// **************** HARDWARE *********************************
//AT16 BOARD V3.3  Halbe Eurokarte 100x80
// **************** HARDWARE *********************************

#define ADMUX_ADC3	0x03
#define ADMUX_5V_REF	0
#define ADMUX_1_14V_REF	0x40
#define ADC_RES	0x400 // 1024

#define LDR_BIT	0x08	//PB3 = ADC3
#define LED_BIT	0x10


#define SET_LED()	(PORTB |= LED_BIT)
#define CLR_LED() (PORTB &= 0xEF)

#define IS_LED_OFF() !(PORTB & LED_BIT)
#define IS_LED_ON()	 (PORTB & LED_BIT)

#define READ_LDR() (PINB & LDR_BIT)


//CHECK PUD = PULLUPDISSABLE in SFIOR 
#define DISABLE_ALL_PULLUP()	(SFIOR |= _BV(PUD));
#define ENABLE_ALLUP_SCL()	(SFIOR &= ~(_BV(PUD)));
// 1.main.c einstellungen
//PORTA
//1=OUT

//CHECK PUD = PULLUPDISSABLE in SFIOR 
//PORT B
//1=OUT
#define PORTB_DDRX_OUT_MSK		LED_BIT			
#define PORTB_PRESET_PULL_MSK	0X00	//Ohne Pullup	

//73,2421875
#define TICKS_5SEC	365
#define TICKS_1SEC	73
#define TICKS_2SEC	146
#define TICKS_100MS	7

#endif  //MAIN_HEADER

